/*
key.c
gcc key.c -I/usr/X11R6/include -L/usr/X11R6/lib -lX11
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <X11/Xlib.h>
#include <X11/keysym.h>
#include <time.h>

#define  max    221
#define  KFIN    52
#define  KSTART  53
#define  KEND    54
#define  KKK     55
#define  NARABI  56
#define  CLK     1.0
#define  NISEN   2000
#define  BYO     100.0
#define  SK      1000
#define  M1F     1000.0
#define  R1F     180.0
#define  R2F     180.0
#define  R3F     180.0
#define  R4F     180.0
#define  T35     45
#define  T18     25

/*   0, 0, 0 黒  15, 0, 0 赤  0,15, 0 緑   0, 0,15 青 */
/*  15,15, 0 黄  15, 0,15 紫  0,15,15 水  15,15,15 白 */

 static char mae[48]={
         0, 0, 0,  12, 8, 0,        10, 0, 0,  10, 0,10,
        11,11,11,  15,15,15,        12, 6, 0,  10,10,10,
         4, 4, 4,   0, 0,15,        15, 0, 0,  15, 0,15,
         0,15, 0,   0,15,15,        15, 0, 8,   0, 0,15  };

 static int lv3[10]={0, 6,12,  18, 24, 30,    36, 42, 48,   54 };
 static int lv4[10]={0, 9,18,  27, 36, 45,    54, 63, 72,   81 };
 static int lv5[10]={0,12,24,  36, 48, 60,    72, 84, 96,  108 };
 static int lv6[10]={0,15,30,  45, 60, 75,    90,105,120,  135 };
 static int lv7[10]={0,18,36,  54, 72, 90,   108,126,144,  162 };
 static int lv8[10]={0,21,42,  63, 84,105,   126,147,168,  189 };

 static char cltable[16][10]={
   {"black"},   {"red"},      {"green"},   {"blue"},
   {"yellow"},  {"violet"},   {"water"},   {"white"},
   {"orange"},  {"cha"},    {"pink"},    {"hada"},
   {"kimi"},    {"oudo"},     {"kon"},     {"hai"}
};


unsigned char data[max][max];
unsigned char data2[max][max];
unsigned char ht[max][NARABI];
unsigned char hy[max][NARABI];
int            it[max][NARABI];
int            iy[max][NARABI];
 
char msg[80];

long aac=0x772222,bbc=0xeeee88;
int notimesave=0;

char sss[200];
double pt1,st1,pt3,st3;
int oldsec=0, nowsec=0;
int oldvsec=0,nowvsec=0;
double gettime();
 
unsigned long d[max],dx;
unsigned int  f[max],f1[max],f2[max];
int  tatemax, yokomax;
int  kmin, kmax;
int  mmax;
int  ls,le;
int  scount,sc;
int  ktmax,kymax;
int  eflag;
clock_t time1, time2;
long extime;
int  dot1,dot2;
int  sl=6,sb=0,sa=0;
int  trace=0;
int  kdata=50;
int  speed=2;
int  length=220;
long nuri=0;

int asc11(char a);

void intro();
void mno_open1(char *file);
void cl_open1(char *file);
void mno_save1();
void ch();
void ch1();
void swe(int i,char yt);
int min11(int a,int b);
int max11(int a,int b);
int  fincount();
void ktymax();
void pr_10x(int suu,int x,int y,int col);
void a_write1(int a,int b,unsigned char *c,int ss);
void chset1(int a, int b,int c,int ss);
void box(int x1,int y1,int fu,int iro);
void errorbox(int x1,int y1,int fu);
void pr_10x2(int suu,int x,int y,int col);
void a_write2(int a,int b,unsigned char *c,int ss);
void chset2(int a, int b,int c,int ss);
void box2(int x1,int y1,int fu,int iro);
void chz(int a, int b,char *p,int ss);
void chx(int a, int b,int ss);
void chc(int a, int b,int ss);
void pr_10x3(int suu,int x,int y,int col);
void a_write3(int a,int b,unsigned char *c,int ss);
void chset3(int a, int b,int c,int ss);

void newz();
void movedata(unsigned char d1[max][max],unsigned char d2[max][max],unsigned char zht1[max][NARABI],unsigned char zht2[max][NARABI],unsigned char zhy1[max][NARABI],unsigned char zhy2[max][NARABI],int zit1[max][NARABI],int zit2[max][NARABI],int ziy1[max][NARABI],int ziy2[max][NARABI]);

int nokori20();
int rote(double dsf);
int mapflg=0,maperr;

void first();
void hantei();
void g_dot(int x, int y);
void g_text(int x, int y,char *str);
void g_line(int x0, int y0, int x1, int y1);
void g_rgb(long iro);
void g_fill(int x0,int y0, int wid, int hei);
void g_box(int x0, int y0, int wid, int hei);
void g_clear();

Display *dpy;
int screen;
Window win, root;
GC gc;
unsigned int win_width=1024, win_height=600;
unsigned int dummy;
XEvent event;
KeySym key_sym;
Atom atom1, atom2;

int loop1=1;

int exx[100],exy[100],exz[100],ex1;
int newt[max],newy[max];
int oldt[max],oldy[max];
char ar2[20],ar3[30],fbc[10];
int fbb;
char cch,uuu[100];
unsigned char test_cl[10]="test.cl",test[10]="test";
unsigned char filet[30];
int argc1,kk;
float tt1=0.0;

 
static char chr_0y[192]={
               0, 0, 4, 4, 4, 4, 4, 4, 4, 4, 0, 0,
               0, 4, 4, 3, 3, 3, 3, 3, 3, 4, 4, 0,
               4, 4, 3, 3, 3, 3, 3, 3, 3, 3, 4, 4,
               4, 3, 3, 3, 4, 4, 4, 4, 3, 3, 3, 4,
               4, 3, 3, 4, 4, 0, 0, 4, 4, 3, 3, 4,
               4, 3, 3, 4, 0, 0, 0, 0, 4, 3, 3, 4,
               4, 3, 3, 4, 0, 0, 0, 0, 4, 3, 3, 4,
               4, 3, 3, 4, 0, 0, 0, 0, 4, 3, 3, 4,
               4, 3, 3, 4, 0, 0, 0, 0, 4, 3, 3, 4,
               4, 3, 3, 4, 0, 0, 0, 0, 4, 3, 3, 4,
               4, 3, 3, 4, 0, 0, 0, 0, 4, 3, 3, 4,
               4, 3, 3, 4, 4, 0, 0, 4, 4, 3, 3, 4,
               4, 3, 3, 3, 4, 4, 4, 4, 3, 3, 3, 4,
               4, 4, 3, 3, 3, 3, 3, 3, 3, 3, 4, 4,
               0, 4, 4, 3, 3, 3, 3, 3, 3, 4, 4, 0,
               0, 0, 4, 4, 4, 4, 4, 4, 4, 4, 0, 0 };
 
 
static char chr_1y[192]={
               0, 0, 0, 0, 4, 4, 4, 4, 0, 0, 0, 0,
               0, 0, 0, 0, 4, 3, 3, 4, 0, 0, 0, 0,
               0, 0, 0, 4, 4, 3, 3, 4, 0, 0, 0, 0,
               0, 4, 4, 4, 3, 3, 3, 4, 0, 0, 0, 0,
               0, 4, 3, 3, 3, 3, 3, 4, 0, 0, 0, 0,
               0, 4, 3, 3, 3, 3, 3, 4, 0, 0, 0, 0,
               0, 4, 4, 4, 4, 3, 3, 4, 0, 0, 0, 0,
               0, 0, 0, 0, 4, 3, 3, 4, 0, 0, 0, 0,
               0, 0, 0, 0, 4, 3, 3, 4, 0, 0, 0, 0,
               0, 0, 0, 0, 4, 3, 3, 4, 0, 0, 0, 0,
               0, 0, 0, 0, 4, 3, 3, 4, 0, 0, 0, 0,
               0, 0, 0, 0, 4, 3, 3, 4, 0, 0, 0, 0,
               0, 0, 4, 4, 4, 3, 3, 4, 4, 4, 0, 0,
               0, 0, 4, 3, 3, 3, 3, 3, 3, 4, 0, 0,
               0, 0, 4, 3, 3, 3, 3, 3, 3, 4, 0, 0,
               0, 0, 4, 4, 4, 4, 4, 4, 4, 4, 0, 0 };
 
 
static char chr_2y[192]={
               0, 0, 4, 4, 4, 4, 4, 4, 4, 4, 0, 0,
               0, 4, 4, 3, 3, 3, 3, 3, 3, 4, 4, 0,
               4, 4, 3, 3, 3, 3, 3, 3, 3, 3, 4, 4,
               4, 3, 3, 3, 4, 4, 4, 4, 3, 3, 3, 4,
               4, 3, 3, 4, 4, 0, 0, 4, 4, 3, 3, 4,
               4, 4, 4, 4, 0, 0, 0, 4, 4, 3, 3, 4,
               0, 0, 4, 4, 4, 4, 4, 4, 3, 3, 3, 4,
               0, 4, 4, 3, 3, 3, 3, 3, 3, 3, 3, 4,
               4, 4, 3, 3, 3, 3, 3, 3, 3, 3, 4, 4,
               4, 3, 3, 3, 4, 4, 4, 4, 4, 4, 4, 0,
               4, 3, 3, 4, 4, 0, 0, 0, 0, 0, 0, 0,
               4, 3, 3, 4, 0, 0, 0, 0, 0, 0, 0, 0,
               4, 3, 3, 4, 4, 4, 4, 4, 4, 4, 4, 4,
               4, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 4,
               4, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 4,
               4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4 };
 
 
static char chr_3y[192]={
               0, 0, 4, 4, 4, 4, 4, 4, 4, 4, 0, 0,
               0, 4, 4, 3, 3, 3, 3, 3, 3, 4, 4, 0,
               4, 4, 3, 3, 3, 3, 3, 3, 3, 3, 4, 4,
               4, 3, 3, 3, 4, 4, 4, 4, 3, 3, 3, 4,
               4, 3, 3, 4, 4, 0, 0, 4, 4, 3, 3, 4,
               4, 4, 4, 4, 0, 0, 0, 4, 4, 3, 3, 4,
               0, 0, 0, 4, 4, 4, 4, 4, 3, 3, 3, 4,
               0, 0, 0, 4, 3, 3, 3, 3, 3, 3, 4, 4,
               0, 0, 0, 4, 3, 3, 3, 3, 3, 3, 4, 4,
               0, 0, 0, 4, 4, 4, 4, 4, 3, 3, 3, 4,
               4, 4, 4, 4, 0, 0, 0, 4, 4, 3, 3, 4,
               4, 3, 3, 4, 4, 0, 0, 4, 4, 3, 3, 4,
               4, 3, 3, 3, 4, 4, 4, 4, 3, 3, 3, 4,
               4, 4, 3, 3, 3, 3, 3, 3, 3, 3, 4, 4,
               0, 4, 4, 3, 3, 3, 3, 3, 3, 4, 4, 0,
               0, 0, 4, 4, 4, 4, 4, 4, 4, 4, 0, 0 };
 
 
static char chr_4y[192]={
               0, 0, 0, 0, 4, 4, 4, 4, 4, 4, 0, 0,
               0, 0, 0, 4, 4, 3, 3, 3, 3, 4, 0, 0,
               0, 0, 4, 4, 3, 3, 3, 3, 3, 4, 0, 0,
               0, 4, 4, 3, 3, 3, 4, 3, 3, 4, 0, 0,
               4, 4, 3, 3, 3, 4, 4, 3, 3, 4, 0, 0,
               4, 3, 3, 3, 4, 4, 4, 3, 3, 4, 0, 0,
               4, 3, 3, 4, 4, 0, 4, 3, 3, 4, 0, 0,
               4, 3, 3, 4, 0, 0, 4, 3, 3, 4, 0, 0,
               4, 3, 3, 4, 4, 4, 4, 3, 3, 4, 4, 4,
               4, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 4,
               4, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 4,
               4, 4, 4, 4, 4, 4, 4, 3, 3, 4, 4, 4,
               0, 0, 0, 0, 0, 0, 4, 3, 3, 4, 0, 0,
               0, 0, 0, 0, 0, 0, 4, 3, 3, 4, 0, 0,
               0, 0, 0, 0, 0, 0, 4, 3, 3, 4, 0, 0,
               0, 0, 0, 0, 0, 0, 4, 4, 4, 4, 0, 0 };
 
 
static char chr_5y[192]={
               4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4,
               4, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 4,
               4, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 4,
               4, 3, 3, 4, 4, 4, 4, 4, 4, 4, 4, 4,
               4, 3, 3, 4, 0, 0, 0, 0, 0, 0, 0, 0,
               4, 3, 3, 4, 4, 4, 4, 4, 4, 4, 4, 0,
               4, 3, 3, 3, 3, 3, 3, 3, 3, 3, 4, 4,
               4, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 4,
               4, 4, 4, 4, 4, 4, 4, 4, 3, 3, 3, 4,
               0, 0, 0, 0, 0, 0, 0, 4, 4, 3, 3, 4,
               0, 0, 0, 0, 0, 0, 0, 0, 4, 3, 3, 4,
               0, 0, 0, 0, 0, 0, 0, 4, 4, 3, 3, 4,
               4, 4, 4, 4, 4, 4, 4, 4, 3, 3, 3, 4,
               4, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 4,
               4, 3, 3, 3, 3, 3, 3, 3, 3, 3, 4, 4,
               4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 0 };
 
 
static char chr_6y[192]={
               0, 0, 0, 0, 4, 4, 4, 4, 4, 4, 4, 4,
               0, 0, 0, 4, 4, 3, 3, 3, 3, 3, 3, 4,
               0, 0, 4, 4, 3, 3, 3, 3, 3, 3, 3, 4,
               0, 4, 4, 3, 3, 3, 4, 4, 4, 4, 4, 4,
               4, 4, 3, 3, 3, 4, 4, 0, 0, 0, 0, 0,
               4, 3, 3, 3, 4, 4, 4, 4, 4, 4, 4, 0,
               4, 3, 3, 3, 3, 3, 3, 3, 3, 3, 4, 4,
               4, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 4,
               4, 3, 3, 4, 4, 4, 4, 4, 3, 3, 3, 4,
               4, 3, 3, 4, 4, 0, 0, 4, 4, 3, 3, 4,
               4, 3, 3, 4, 0, 0, 0, 0, 4, 3, 3, 4,
               4, 3, 3, 4, 4, 0, 0, 4, 4, 3, 3, 4,
               4, 3, 3, 3, 4, 4, 4, 4, 3, 3, 3, 4,
               4, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 4,
               4, 4, 3, 3, 3, 3, 3, 3, 3, 3, 4, 4,
               0, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 0 };
 
 
static char chr_7y[192]={
               4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4,
               4, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 4,
               4, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 4,
               4, 3, 3, 4, 4, 4, 4, 4, 4, 3, 3, 4,
               4, 3, 3, 4, 0, 0, 0, 4, 4, 3, 3, 4,
               4, 4, 4, 4, 0, 0, 4, 4, 3, 3, 3, 4,
               0, 0, 0, 0, 0, 4, 4, 3, 3, 3, 4, 4,
               0, 0, 0, 0, 4, 4, 3, 3, 3, 4, 4, 0,
               0, 0, 0, 0, 4, 3, 3, 3, 4, 4, 0, 0,
               0, 0, 0, 0, 4, 3, 3, 4, 4, 0, 0, 0,
               0, 0, 0, 0, 4, 3, 3, 4, 0, 0, 0, 0,
               0, 0, 0, 0, 4, 3, 3, 4, 0, 0, 0, 0,
               0, 0, 0, 0, 4, 3, 3, 4, 0, 0, 0, 0,
               0, 0, 0, 0, 4, 3, 3, 4, 0, 0, 0, 0,
               0, 0, 0, 0, 4, 3, 3, 4, 0, 0, 0, 0,
               0, 0, 0, 0, 4, 4, 4, 4, 0, 0, 0, 0 };
 
 
static char chr_8y[192]={
               0, 0, 4, 4, 4, 4, 4, 4, 4, 4, 0, 0,
               0, 0, 4, 3, 3, 3, 3, 3, 3, 4, 0, 0,
               0, 4, 4, 3, 3, 3, 3, 3, 3, 4, 4, 0,
               0, 4, 3, 3, 4, 4, 4, 4, 3, 3, 4, 0,
               0, 4, 3, 3, 4, 0, 0, 4, 3, 3, 4, 0,
               0, 4, 3, 3, 4, 4, 4, 4, 3, 3, 4, 0,
               0, 4, 3, 3, 3, 3, 3, 3, 3, 3, 4, 0,
               4, 4, 3, 3, 3, 3, 3, 3, 3, 3, 4, 4,
               4, 3, 3, 3, 4, 4, 4, 4, 3, 3, 3, 4,
               4, 3, 3, 4, 4, 0, 0, 4, 4, 3, 3, 4,
               4, 3, 3, 4, 0, 0, 0, 0, 4, 3, 3, 4,
               4, 3, 3, 4, 4, 0, 0, 4, 4, 3, 3, 4,
               4, 3, 3, 3, 4, 4, 4, 4, 3, 3, 3, 4,
               4, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 4,
               4, 4, 3, 3, 3, 3, 3, 3, 3, 3, 4, 4,
               0, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 0 };
 
 
static char chr_9y[192]={
               0, 0, 4, 4, 4, 4, 4, 4, 4, 4, 4, 0,
               0, 4, 4, 3, 3, 3, 3, 3, 3, 3, 4, 4,
               4, 4, 3, 3, 3, 3, 3, 3, 3, 3, 3, 4,
               4, 3, 3, 3, 4, 4, 4, 4, 3, 3, 3, 4,
               4, 3, 3, 4, 4, 0, 0, 4, 4, 3, 3, 4,
               4, 3, 3, 4, 0, 0, 0, 0, 4, 3, 3, 4,
               4, 3, 3, 4, 4, 0, 0, 4, 4, 3, 3, 4,
               4, 3, 3, 3, 4, 4, 4, 4, 3, 3, 3, 4,
               4, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 4,
               4, 4, 3, 3, 3, 3, 3, 3, 3, 3, 3, 4,
               0, 4, 4, 4, 4, 4, 4, 4, 3, 3, 3, 4,
               0, 0, 0, 0, 0, 0, 4, 4, 3, 3, 3, 4,
               4, 4, 4, 4, 4, 4, 4, 3, 3, 3, 4, 4,
               4, 3, 3, 3, 3, 3, 3, 3, 3, 4, 4, 0,
               4, 3, 3, 3, 3, 3, 3, 3, 4, 4, 0, 0,
               4, 4, 4, 4, 4, 4, 4, 4, 4, 0, 0, 0 };
 
static char chr_9xt[99]={
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0 };
 

static char chr_0x[99]={
               0, 0, 1, 3, 3, 3, 1, 0, 0,
               0, 1, 3, 3, 3, 3, 3, 1, 0,
               2, 3, 1, 0, 0, 0, 1, 3, 2,
               3, 3, 1, 0, 0, 1, 3, 3, 3,
               3, 3, 0, 0, 1, 3, 1, 3, 3,
               3, 3, 0, 1, 3, 1, 0, 3, 3,
               3, 3, 1, 3, 1, 0, 0, 3, 3,
               3, 3, 3, 1, 0, 0, 1, 3, 3,
               2, 3, 1, 0, 0, 0, 1, 3, 2,
               0, 1, 3, 3, 3, 3, 3, 1, 0,
               0, 0, 1, 3, 3, 3, 1, 0, 0 };

static char chr_1x[99]={
               0, 0, 0, 0, 3, 3, 0, 0, 0,
               0, 0, 0, 1, 3, 3, 0, 0, 0,
               0, 0, 3, 3, 3, 3, 0, 0, 0,
               0, 0, 3, 3, 3, 3, 0, 0, 0,
               0, 0, 0, 0, 3, 3, 0, 0, 0,
               0, 0, 0, 0, 3, 3, 0, 0, 0,
               0, 0, 0, 0, 3, 3, 0, 0, 0,
               0, 0, 0, 0, 3, 3, 0, 0, 0,
               0, 0, 0, 0, 3, 3, 0, 0, 0,
               0, 0, 3, 3, 3, 3, 3, 3, 0,
               0, 0, 3, 3, 3, 3, 3, 3, 0 };
 
static char chr_2x[99]={
               0, 0, 1, 3, 3, 3, 1, 0, 0,
               0, 1, 3, 3, 3, 3, 3, 1, 0,
               1, 3, 1, 0, 0, 0, 1, 3, 1,
               3, 3, 0, 0, 0, 0, 0, 3, 3,
               0, 0, 0, 0, 0, 0, 0, 3, 3,
               0, 0, 0, 0, 0, 1, 3, 3, 1,
               0, 0, 0, 1, 3, 3, 1, 0, 0,
               0, 1, 3, 3, 1, 0, 0, 0, 0,
               1, 3, 1, 0, 0, 0, 0, 0, 0,
               3, 3, 3, 3, 3, 3, 3, 3, 3,
               3, 3, 3, 3, 3, 3, 3, 3, 3 };
 

static char chr_3x[99]={
               0, 0, 1, 3, 3, 3, 1, 0, 0,
               0, 1, 3, 3, 3, 3, 3, 1, 0,
               0, 3, 1, 0, 0, 0, 1, 3, 1,
               0, 0, 0, 0, 0, 0, 1, 3, 1,
               0, 0, 0, 0, 3, 3, 3, 1, 0,
               0, 0, 0, 0, 3, 3, 3, 3, 0,
               0, 0, 0, 0, 0, 0, 1, 3, 1,
               3, 3, 0, 0, 0, 0, 0, 3, 3,
               1, 3, 1, 0, 0, 0, 1, 3, 1,
               0, 1, 3, 3, 3, 3, 3, 1, 0,
               0, 0, 1, 3, 3, 3, 1, 0, 0 };
 
 
static char chr_4x[99]={
               0, 0, 0, 1, 3, 3, 3, 0, 0,
               0, 0, 1, 3, 1, 3, 3, 0, 0,
               0, 1, 3, 1, 0, 3, 3, 0, 0,
               1, 3, 1, 0, 0, 3, 3, 0, 0,
               3, 3, 0, 0, 0, 3, 3, 0, 0,
               3, 3, 0, 0, 0, 3, 3, 0, 0,
               3, 3, 0, 0, 0, 3, 3, 0, 0,
               3, 3, 3, 3, 3, 3, 3, 3, 3,
               3, 3, 3, 3, 3, 3, 3, 3, 3,
               0, 0, 0, 0, 0, 3, 3, 0, 0,
               0, 0, 0, 0, 0, 3, 3, 0, 0 };
 

static char chr_5x[99]={
               3, 3, 3, 3, 3, 3, 3, 3, 3,
               3, 3, 3, 3, 3, 3, 3, 3, 3,
               3, 3, 0, 0, 0, 0, 0, 0, 0,
               3, 3, 0, 0, 0, 0, 0, 0, 0,
               3, 3, 3, 3, 3, 3, 3, 1, 0,
               3, 3, 3, 3, 3, 3, 3, 3, 1,
               0, 0, 0, 0, 0, 0, 1, 3, 3,
               0, 0, 0, 0, 0, 0, 0, 3, 3,
               0, 0, 0, 0, 0, 0, 1, 3, 1,
               3, 3, 3, 3, 3, 3, 3, 1, 0,
               3, 3, 3, 3, 3, 3, 1, 0, 0 };
 
static char chr_6x[99]={
               0, 0, 0, 3, 3, 3, 3, 1, 0,
               0, 0, 1, 3, 3, 3, 3, 0, 0,
               0, 1, 3, 3, 1, 0, 0, 0, 0,
               0, 1, 3, 1, 0, 0, 0, 0, 0,
               1, 3, 3, 3, 3, 3, 3, 1, 0,
               3, 3, 3, 3, 3, 3, 3, 3, 1,
               3, 3, 0, 0, 0, 0, 0, 3, 3,
               3, 3, 0, 0, 0, 0, 0, 3, 3,
               1, 3, 1, 0, 0, 0, 1, 3, 1,
               0, 1, 3, 3, 3, 3, 3, 1, 0,
               0, 0, 1, 3, 3, 3, 1, 0, 0 };
 
 
static char chr_7x[99]={
               3, 3, 3, 3, 3, 3, 3, 3, 3,
               3, 3, 3, 3, 3, 3, 3, 3, 3,
               3, 3, 0, 0, 0, 0, 0, 3, 3,
               3, 3, 0, 0, 0, 0, 0, 3, 3,
               0, 0, 0, 0, 0, 0, 1, 3, 1,
               0, 0, 0, 0, 0, 1, 3, 1, 0,
               0, 0, 0, 0, 1, 3, 1, 0, 0,
               0, 0, 0, 1, 3, 1, 0, 0, 0,
               0, 0, 0, 3, 3, 0, 0, 0, 0,
               0, 0, 0, 3, 3, 0, 0, 0, 0,
               0, 0, 0, 3, 3, 0, 0, 0, 0 };
 

static char chr_8x[99]={
               0, 0, 1, 3, 3, 3, 1, 0, 0,
               0, 1, 3, 3, 3, 3, 3, 1, 0,
               0, 3, 3, 0, 0, 0, 3, 3, 0,
               0, 1, 3, 0, 0, 0, 3, 1, 0,
               0, 1, 3, 3, 3, 3, 3, 1, 0,
               1, 3, 3, 3, 3, 3, 3, 3, 1,
               3, 3, 1, 0, 0, 0, 1, 3, 3,
               3, 3, 0, 0, 0, 0, 0, 3, 3,
               1, 3, 1, 0, 0, 0, 1, 3, 1,
               0, 1, 3, 3, 3, 3, 3, 1, 0,
               0, 0, 1, 3, 3, 3, 1, 0, 0 };
 
 
static char chr_9x[99]={
               0, 0, 1, 3, 3, 3, 1, 0, 0,
               0, 1, 3, 3, 3, 3, 3, 1, 0,
               1, 3, 1, 0, 0, 0, 1, 3, 1,
               3, 3, 0, 0, 0, 0, 0, 3, 3,
               3, 3, 1, 0, 0, 0, 1, 3, 3,
               1, 3, 3, 3, 3, 3, 3, 3, 1,
               0, 1, 3, 3, 3, 3, 3, 3, 1,
               0, 0, 0, 0, 1, 3, 3, 1, 0,
               0, 0, 0, 2, 3, 3, 1, 0, 0,
               3, 3, 3, 3, 3, 1, 0, 0, 0,
               3, 3, 3, 1, 0, 0, 0, 0, 0 };
 
 
static char chr_ax[99]={
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 2, 3, 3, 3, 3, 1, 0, 0,
               2, 3, 3, 3, 3, 3, 3, 1, 0,
               1, 0, 0, 0, 0, 0, 1, 3, 1,
               0, 1, 3, 3, 3, 3, 3, 3, 3,
               0, 1, 3, 3, 3, 3, 3, 3, 3,
               1, 3, 1, 0, 0, 0, 1, 3, 3,
               1, 3, 1, 0, 0, 1, 3, 3, 3,
               0, 1, 3, 3, 3, 3, 1, 3, 3,
               0, 0, 1, 3, 3, 1, 0, 3, 3 };
 
 
static char chr_bx[99]={
               3, 3, 0, 0, 0, 0, 0, 0, 0,
               3, 3, 0, 0, 0, 0, 0, 0, 0,
               3, 3, 0, 0, 0, 0, 0, 0, 0,
               3, 3, 3, 3, 3, 3, 3, 1, 0,
               3, 3, 3, 3, 3, 3, 3, 3, 1,
               3, 3, 0, 0, 0, 0, 1, 3, 1,
               3, 3, 0, 0, 0, 0, 0, 3, 3,
               3, 3, 0, 0, 0, 0, 0, 3, 3,
               3, 3, 0, 0, 0, 0, 1, 3, 1,
               3, 3, 3, 3, 3, 3, 3, 1, 0,
               3, 3, 3, 3, 3, 3, 1, 0, 0 };
 
 
static char chr_cx[99]={
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 1, 3, 3, 3, 1, 0, 0,
               0, 1, 3, 3, 3, 3, 3, 1, 0,
               1, 3, 1, 0, 0, 0, 1, 3, 1,
               3, 3, 0, 0, 0, 0, 0, 0, 0,
               3, 3, 0, 0, 0, 0, 0, 0, 0,
               1, 3, 1, 0, 0, 0, 1, 3, 1,
               0, 1, 3, 3, 3, 3, 3, 1, 0,
               0, 0, 1, 3, 3, 3, 1, 0, 0 };
 
 
static char chr_dx[99]={
               0, 0, 0, 0, 0, 0, 0, 3, 3,
               0, 0, 0, 0, 0, 0, 0, 3, 3,
               0, 0, 0, 0, 0, 0, 0, 3, 3,
               0, 0, 1, 3, 3, 3, 3, 3, 3,
               0, 1, 3, 3, 3, 3, 3, 3, 3,
               1, 3, 1, 0, 0, 0, 0, 3, 3,
               3, 3, 0, 0, 0, 0, 0, 3, 3,
               3, 3, 0, 0, 0, 0, 0, 3, 3,
               1, 3, 1, 0, 0, 0, 0, 3, 3,
               0, 1, 3, 3, 3, 3, 3, 3, 3,
               0, 0, 1, 3, 3, 3, 3, 3, 3 };
 
 
static char chr_ex[99]={
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 1, 3, 3, 3, 1, 0, 0,
               0, 1, 3, 3, 3, 3, 3, 1, 0,
               1, 3, 1, 0, 0, 0, 1, 3, 1,
               3, 3, 0, 0, 0, 0, 0, 3, 3,
               3, 3, 3, 3, 3, 3, 3, 3, 3,
               3, 3, 3, 3, 3, 3, 3, 3, 3,
               1, 3, 1, 0, 0, 0, 0, 0, 0,
               0, 1, 3, 3, 3, 3, 3, 3, 1,
               0, 0, 1, 3, 3, 3, 3, 1, 0 };
 
 
static char chr_fx[99]={
               0, 0, 0, 0, 1, 3, 3, 3, 3,
               0, 0, 0, 1, 3, 3, 3, 3, 3,
               0, 0, 0, 3, 3, 1, 0, 0, 0,
               0, 0, 0, 3, 3, 0, 0, 0, 0,
               3, 3, 3, 3, 3, 3, 3, 3, 0,
               3, 3, 3, 3, 3, 3, 3, 3, 0,
               0, 0, 0, 3, 3, 0, 0, 0, 0,
               0, 0, 0, 3, 3, 0, 0, 0, 0,
               0, 0, 0, 3, 3, 0, 0, 0, 0,
               0, 0, 0, 3, 3, 0, 0, 0, 0,
               0, 0, 0, 3, 3, 0, 0, 0, 0 };
 
 
static char chr_gx[99]={
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 1, 3, 3, 3, 2, 3, 3,
               0, 1, 3, 3, 3, 3, 1, 3, 3,
               1, 3, 1, 0, 0, 2, 3, 3, 3,
               1, 3, 1, 0, 0, 0, 2, 3, 3,
               1, 3, 1, 0, 0, 0, 1, 3, 3,
               0, 1, 3, 3, 3, 3, 3, 3, 3,
               0, 0, 1, 3, 3, 3, 2, 3, 3,
               1, 3, 0, 0, 0, 0, 1, 3, 1,
               0, 1, 3, 3, 3, 3, 3, 1, 0,
               0, 0, 1, 3, 3, 3, 1, 0, 0 };
 
 
static char chr_hx[99]={
               3, 3, 0, 0, 0, 0, 0, 0, 0,
               3, 3, 0, 0, 0, 0, 0, 0, 0,
               3, 3, 0, 0, 0, 0, 0, 0, 0,
               3, 3, 0, 0, 0, 0, 0, 0, 0,
               3, 3, 3, 3, 3, 3, 1, 0, 0,
               3, 3, 3, 3, 3, 3, 3, 1, 0,
               3, 3, 0, 0, 0, 0, 1, 3, 1,
               3, 3, 0, 0, 0, 0, 0, 3, 3,
               3, 3, 0, 0, 0, 0, 0, 3, 3,
               3, 3, 0, 0, 0, 0, 0, 3, 3,
               3, 3, 0, 0, 0, 0, 0, 3, 3 };
 
 
static char chr_ix[99]={
               0, 0, 0, 0, 3, 3, 0, 0, 0,
               0, 0, 0, 0, 3, 3, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 1, 1, 0, 0, 0,
               0, 0, 0, 0, 3, 3, 0, 0, 0,
               0, 0, 0, 0, 3, 3, 0, 0, 0,
               0, 0, 0, 0, 3, 3, 0, 0, 0,
               0, 0, 0, 0, 3, 3, 0, 0, 0,
               0, 0, 0, 0, 3, 3, 0, 0, 0,
               0, 0, 0, 0, 3, 3, 0, 0, 0,
               0, 0, 0, 0, 3, 3, 0, 0, 0 };
 
 
static char chr_jx[99]={
               0, 0, 0, 0, 0, 0, 3, 3, 0,
               0, 0, 0, 0, 0, 0, 3, 3, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 1, 1, 0,
               0, 0, 0, 0, 0, 0, 3, 3, 0,
               0, 0, 0, 0, 0, 0, 3, 3, 0,
               3, 3, 0, 0, 0, 0, 3, 3, 0,
               3, 3, 0, 0, 0, 0, 3, 3, 0,
               1, 3, 1, 0, 0, 1, 3, 3, 0,
               0, 1, 3, 3, 3, 3, 3, 1, 0,
               0, 0, 1, 3, 3, 3, 1, 0, 0 };
 
 
static char chr_kx[99]={
               3, 3, 0, 0, 0, 0, 0, 0, 0,
               3, 3, 0, 0, 0, 0, 0, 0, 0,
               3, 3, 0, 0, 0, 0, 0, 1, 3,
               3, 3, 0, 0, 0, 0, 1, 3, 1,
               3, 3, 0, 0, 0, 1, 3, 1, 0,
               3, 3, 0, 0, 1, 3, 1, 0, 0,
               3, 3, 0, 1, 3, 3, 0, 0, 0,
               3, 3, 1, 3, 1, 3, 1, 0, 0,
               3, 3, 3, 1, 0, 1, 3, 1, 0,
               3, 3, 1, 0, 0, 0, 1, 3, 1,
               3, 3, 0, 0, 0, 0, 0, 1, 3 };
 
 
static char chr_lx[99]={
               0, 0, 0, 0, 3, 1, 0, 0, 0,
               0, 0, 0, 1, 3, 3, 1, 0, 0,
               0, 0, 0, 3, 1, 3, 3, 0, 0,
               0, 0, 2, 3, 0, 3, 3, 0, 0,
               0, 0, 2, 3, 0, 3, 3, 0, 0,
               0, 0, 2, 3, 0, 3, 3, 0, 0,
               0, 0, 2, 3, 1, 3, 1, 0, 0,
               0, 0, 0, 3, 2, 3, 1, 0, 0,
               0, 0, 1, 3, 3, 3, 1, 0, 0,
               0, 1, 3, 3, 3, 3, 3, 3, 1,
               0, 3, 3, 1, 0, 1, 3, 3, 3 };
 
 
static char chr_mx[99]={
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 3, 3, 2, 1, 2, 1, 2, 0,
               0, 3, 3, 3, 3, 3, 3, 3, 2,
               0, 3, 3, 3, 3, 3, 3, 3, 3,
               0, 3, 3, 0, 3, 3, 0, 3, 3,
               0, 3, 3, 0, 3, 3, 0, 3, 3,
               0, 3, 3, 0, 3, 3, 0, 3, 3,
               0, 3, 3, 0, 3, 3, 0, 3, 3,
               0, 3, 3, 0, 3, 3, 0, 3, 3,
               0, 3, 3, 0, 3, 3, 0, 3, 3 };
 
 
static char chr_nx[99]={
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 3, 3, 2, 1, 1, 1, 0, 0,
               0, 3, 3, 3, 3, 3, 3, 1, 0,
               0, 3, 3, 1, 1, 1, 1, 3, 0,
               0, 3, 3, 2, 0, 0, 2, 3, 1,
               0, 3, 3, 0, 0, 0, 0, 3, 3,
               0, 3, 3, 0, 0, 0, 0, 3, 3,
               0, 3, 3, 0, 0, 0, 0, 3, 3,
               0, 3, 3, 0, 0, 0, 0, 3, 3,
               0, 3, 3, 0, 0, 0, 0, 3, 3 };

 
static char chr_ox[99]={
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 1, 3, 3, 3, 1, 0, 0,
               0, 1, 3, 3, 3, 3, 3, 1, 0,
               1, 3, 1, 0, 0, 0, 1, 3, 1,
               3, 3, 0, 0, 0, 0, 0, 3, 3,
               3, 3, 0, 0, 0, 0, 0, 3, 3,
               1, 3, 1, 0, 0, 0, 1, 3, 1,
               0, 1, 3, 3, 3, 3, 3, 1, 0,
               0, 0, 1, 3, 3, 3, 1, 0, 0 };
 
 
static char chr_px[99]={
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               3, 3, 3, 3, 3, 3, 1, 0, 0,
               3, 3, 3, 3, 3, 3, 3, 1, 0,
               3, 3, 0, 0, 0, 0, 1, 3, 1,
               3, 3, 0, 0, 0, 0, 0, 3, 3,
               3, 3, 0, 0, 0, 0, 1, 3, 1,
               3, 3, 3, 3, 3, 3, 3, 1, 0,
               3, 3, 3, 3, 3, 3, 1, 0, 0,
               3, 3, 0, 0, 0, 0, 0, 0, 0,
               3, 3, 0, 0, 0, 0, 0, 0, 0 };
 
 
static char chr_qx[99]={
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 1, 3, 3, 3, 3, 3, 3,
               0, 1, 3, 3, 3, 3, 3, 3, 3,
               1, 3, 1, 0, 0, 0, 0, 3, 3,
               3, 3, 0, 0, 0, 0, 0, 3, 3,
               1, 3, 1, 0, 0, 0, 0, 3, 3,
               0, 1, 3, 3, 3, 3, 3, 3, 3,
               0, 0, 1, 3, 3, 3, 3, 3, 3,
               0, 0, 0, 0, 0, 0, 0, 3, 3,
               0, 0, 0, 0, 0, 0, 0, 3, 3 };
 
 
static char chr_rx[99]={
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               3, 3, 0, 0, 1, 3, 3, 3, 0,
               3, 3, 0, 1, 3, 3, 3, 3, 0,
               3, 3, 1, 3, 1, 0, 0, 0, 0,
               3, 3, 3, 1, 0, 0, 0, 0, 0,
               3, 3, 3, 0, 0, 0, 0, 0, 0,
               3, 3, 1, 0, 0, 0, 0, 0, 0,
               3, 3, 0, 0, 0, 0, 0, 0, 0,
               3, 3, 0, 0, 0, 0, 0, 0, 0 };
 
 
static char chr_sx[99]={
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 1, 3, 3, 3, 1, 0, 0,
               0, 1, 3, 3, 3, 3, 3, 1, 0,
               1, 3, 1, 0, 0, 0, 0, 0, 0,
               1, 3, 3, 3, 3, 3, 1, 0, 0,
               0, 1, 3, 3, 3, 3, 3, 1, 0,
               0, 0, 0, 0, 0, 0, 1, 3, 1,
               1, 3, 3, 3, 3, 3, 3, 1, 0,
               0, 1, 3, 3, 3, 3, 1, 0, 0 };
 
 
static char chr_tx[99]={
               0, 0, 0, 3, 3, 0, 0, 0, 0,
               0, 0, 0, 3, 3, 0, 0, 0, 0,
               0, 0, 0, 3, 3, 0, 0, 0, 0,
               0, 3, 3, 3, 3, 3, 3, 0, 0,
               0, 3, 3, 3, 3, 3, 3, 0, 0,
               0, 0, 0, 3, 3, 0, 0, 0, 0,
               0, 0, 0, 3, 3, 0, 0, 0, 0,
               0, 0, 0, 3, 3, 0, 0, 0, 0,
               0, 0, 0, 3, 3, 1, 0, 0, 0,
               0, 0, 0, 1, 3, 3, 3, 3, 0,
               0, 0, 0, 0, 1, 3, 3, 3, 0 };
 
 
static char chr_ux[99]={
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               3, 3, 0, 0, 0, 0, 0, 3, 3,
               3, 3, 0, 0, 0, 0, 0, 3, 3,
               3, 3, 0, 0, 0, 0, 0, 3, 3,
               3, 3, 0, 0, 0, 0, 0, 3, 3,
               3, 3, 0, 0, 0, 0, 1, 3, 3,
               1, 3, 1, 0, 0, 1, 3, 3, 3,
               0, 1, 3, 3, 3, 3, 1, 3, 3,
               0, 0, 1, 3, 3, 1, 0, 3, 3 };
 
 
static char chr_vx[99]={
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               3, 3, 0, 0, 0, 0, 0, 3, 3,
               3, 3, 0, 0, 0, 0, 0, 3, 3,
               3, 3, 1, 0, 0, 0, 1, 3, 3,
               1, 3, 1, 0, 0, 0, 1, 3, 1,
               0, 1, 3, 1, 0, 1, 3, 1, 0,
               0, 0, 1, 3, 1, 3, 1, 0, 0,
               0, 0, 1, 3, 3, 3, 1, 0, 0,
               0, 0, 0, 1, 3, 1, 0, 0, 0 };
 
 
static char chr_wx[99]={
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               3, 3, 0, 0, 0, 0, 0, 3, 3,
               3, 3, 0, 0, 1, 0, 0, 3, 3,
               1, 3, 2, 1, 3, 1, 2, 3, 1,
               1, 3, 1, 3, 1, 3, 1, 3, 1,
               0, 3, 3, 3, 0, 3, 3, 3, 0,
               0, 3, 3, 1, 0, 1, 3, 3, 0,
               0, 3, 3, 0, 0, 0, 3, 3, 0,
               0, 3, 3, 0, 0, 0, 3, 3, 0 };
 
 
static char chr_xx[99]={
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               3, 3, 1, 0, 0, 0, 1, 3, 3,
               0, 1, 3, 1, 0, 1, 3, 1, 0,
               0, 0, 1, 3, 1, 3, 1, 0, 0,
               0, 0, 0, 1, 3, 1, 0, 0, 0,
               0, 0, 1, 3, 1, 3, 1, 0, 0,
               0, 1, 3, 1, 0, 1, 3, 1, 0,
               1, 3, 1, 0, 0, 0, 1, 3, 1,
               3, 3, 0, 0, 0, 0, 0, 3, 3 };
 
 
static char chr_yx[99]={
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               3, 3, 0, 0, 0, 0, 0, 3, 3,
               3, 3, 0, 0, 0, 0, 0, 3, 3,
               1, 3, 1, 0, 0, 0, 1, 3, 1,
               0, 1, 3, 1, 0, 1, 3, 1, 0,
               0, 0, 1, 3, 3, 3, 1, 0, 0,
               0, 0, 0, 1, 3, 1, 0, 0, 0,
               1, 3, 3, 3, 1, 0, 0, 0, 0,
               3, 3, 3, 1, 0, 0, 0, 0, 0 };
 
 
static char chr_zx[99]={
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               3, 3, 3, 3, 3, 3, 3, 3, 3,
               3, 3, 3, 3, 3, 3, 3, 3, 3,
               0, 0, 2, 0, 0, 1, 3, 1, 0,
               0, 0, 0, 1, 3, 3, 1, 0, 0,
               0, 0, 0, 1, 3, 3, 1, 0, 0,
               0, 1, 3, 1, 0, 0, 2, 0, 0,
               3, 3, 3, 3, 3, 3, 3, 3, 3,
               3, 3, 3, 3, 3, 3, 3, 3, 3 };
 
 
static char chr_Ax[99]={
               0, 0, 0, 1, 3, 1, 0, 0, 0,
               0, 0, 0, 3, 3, 3, 0, 0, 0,
               0, 0, 1, 3, 1, 3, 1, 0, 0,
               0, 0, 3, 3, 0, 3, 3, 0, 0,
               0, 1, 3, 3, 0, 3, 3, 1, 0,
               0, 3, 3, 0, 0, 0, 3, 3, 0,
               1, 3, 3, 0, 0, 0, 3, 3, 1,
               1, 3, 3, 3, 3, 3, 3, 3, 3,
               1, 3, 3, 3, 3, 3, 3, 3, 3,
               3, 3, 0, 0, 0, 0, 0, 3, 3,
               3, 3, 0, 0, 0, 0, 0, 3, 3 };
 
 
static char chr_Bx[99]={
               3, 3, 3, 3, 3, 3, 1, 0, 0,
               3, 3, 3, 3, 3, 3, 3, 1, 0,
               3, 3, 0, 0, 0, 1, 3, 1, 0,
               3, 3, 0, 0, 0, 1, 3, 1, 0,
               3, 3, 3, 3, 3, 3, 1, 0, 0,
               3, 3, 3, 3, 3, 3, 3, 3, 1,
               3, 3, 0, 0, 0, 0, 1, 3, 3,
               3, 3, 0, 0, 0, 0, 0, 3, 3,
               3, 3, 0, 0, 0, 0, 1, 3, 1,
               3, 3, 3, 3, 3, 3, 3, 1, 0,
               3, 3, 3, 3, 3, 3, 1, 0, 0 };
 
 
static char chr_Cx[99]={
               0, 0, 1, 3, 3, 3, 1, 0, 0,
               0, 1, 3, 3, 3, 3, 3, 1, 0,
               1, 3, 1, 0, 0, 0, 1, 3, 1,
               3, 3, 0, 0, 0, 0, 0, 3, 3,
               3, 3, 0, 0, 0, 0, 0, 0, 0,
               3, 3, 0, 0, 0, 0, 0, 0, 0,
               3, 3, 0, 0, 0, 0, 0, 0, 0,
               3, 3, 0, 0, 0, 0, 0, 3, 3,
               1, 3, 1, 0, 0, 0, 1, 3, 1,
               0, 1, 3, 3, 3, 3, 3, 1, 0,
               0, 0, 1, 3, 3, 3, 1, 0, 0 };
 
 
static char chr_Dx[99]={
               3, 3, 3, 3, 3, 1, 0, 0, 0,
               3, 3, 3, 3, 3, 3, 1, 0, 0,
               3, 3, 0, 0, 0, 1, 3, 1, 0,
               3, 3, 0, 0, 0, 0, 1, 3, 1,
               3, 3, 0, 0, 0, 0, 0, 3, 3,
               3, 3, 0, 0, 0, 0, 0, 3, 3,
               3, 3, 0, 0, 0, 0, 0, 3, 3,
               3, 3, 0, 0, 0, 0, 1, 3, 1,
               3, 3, 0, 0, 0, 1, 3, 1, 0,
               3, 3, 3, 3, 3, 3, 1, 0, 0,
               3, 3, 3, 3, 3, 1, 0, 0, 0 };
 
 
static char chr_Ex[99]={
               3, 3, 3, 3, 3, 3, 3, 3, 3,
               3, 3, 3, 3, 3, 3, 3, 3, 3,
               3, 3, 0, 0, 0, 0, 0, 0, 0,
               3, 3, 0, 0, 0, 0, 0, 0, 0,
               3, 3, 3, 3, 3, 3, 3, 0, 0,
               3, 3, 3, 3, 3, 3, 3, 0, 0,
               3, 3, 0, 0, 0, 0, 0, 0, 0,
               3, 3, 0, 0, 0, 0, 0, 0, 0,
               3, 3, 0, 0, 0, 0, 0, 0, 0,
               3, 3, 3, 3, 3, 3, 3, 3, 3,
               3, 3, 3, 3, 3, 3, 3, 3, 3 };
 
 
static char chr_Fx[99]={
               3, 3, 3, 3, 3, 3, 3, 3, 3,
               3, 3, 3, 3, 3, 3, 3, 3, 3,
               3, 3, 0, 0, 0, 0, 0, 0, 0,
               3, 3, 0, 0, 0, 0, 0, 0, 0,
               3, 3, 0, 0, 0, 0, 0, 0, 0,
               3, 3, 3, 3, 3, 3, 3, 0, 0,
               3, 3, 3, 3, 3, 3, 3, 0, 0,
               3, 3, 0, 0, 0, 0, 0, 0, 0,
               3, 3, 0, 0, 0, 0, 0, 0, 0,
               3, 3, 0, 0, 0, 0, 0, 0, 0,
               3, 3, 0, 0, 0, 0, 0, 0, 0 };
 
 
static char chr_Gx[99]={
               0, 0, 1, 3, 3, 3, 3, 1, 0,
               0, 1, 3, 3, 3, 3, 3, 3, 1,
               1, 3, 1, 0, 0, 0, 1, 3, 3,
               3, 3, 0, 0, 0, 0, 0, 0, 0,
               3, 3, 0, 0, 3, 3, 3, 3, 3,
               3, 3, 0, 0, 3, 3, 3, 3, 3,
               3, 3, 0, 0, 0, 0, 0, 3, 3,
               3, 3, 0, 0, 0, 0, 0, 3, 3,
               1, 3, 1, 0, 0, 0, 1, 3, 1,
               0, 1, 3, 3, 3, 3, 3, 1, 0,
               0, 0, 1, 3, 3, 3, 1, 0, 0 };
 
 
static char chr_Hx[99]={
               3, 3, 0, 0, 0, 0, 0, 3, 3,
               3, 3, 0, 0, 0, 0, 0, 3, 3,
               3, 3, 0, 0, 0, 0, 0, 3, 3,
               3, 3, 0, 0, 0, 0, 0, 3, 3,
               3, 3, 3, 3, 3, 3, 3, 3, 3,
               3, 3, 3, 3, 3, 3, 3, 3, 3,
               3, 3, 0, 0, 0, 0, 0, 3, 3,
               3, 3, 0, 0, 0, 0, 0, 3, 3,
               3, 3, 0, 0, 0, 0, 0, 3, 3,
               3, 3, 0, 0, 0, 0, 0, 3, 3,
               3, 3, 0, 0, 0, 0, 0, 3, 3 };
 
 
static char chr_Ix[99]={
               0, 0, 3, 3, 3, 3, 3, 3, 0,
               0, 0, 3, 3, 3, 3, 3, 3, 0,
               0, 0, 0, 0, 3, 3, 0, 0, 0,
               0, 0, 0, 0, 3, 3, 0, 0, 0,
               0, 0, 0, 0, 3, 3, 0, 0, 0,
               0, 0, 0, 0, 3, 3, 0, 0, 0,
               0, 0, 0, 0, 3, 3, 0, 0, 0,
               0, 0, 0, 0, 3, 3, 0, 0, 0,
               0, 0, 0, 0, 3, 3, 0, 0, 0,
               0, 0, 3, 3, 3, 3, 3, 3, 0,
               0, 0, 3, 3, 3, 3, 3, 3, 0 };
 
 
static char chr_Jx[99]={
               0, 0, 0, 0, 3, 3, 3, 3, 3,
               0, 0, 0, 0, 3, 3, 3, 3, 3,
               0, 0, 0, 0, 0, 0, 3, 3, 0,
               0, 0, 0, 0, 0, 0, 3, 3, 0,
               0, 0, 0, 0, 0, 0, 3, 3, 0,
               0, 0, 0, 0, 0, 0, 3, 3, 0,
               3, 3, 0, 0, 0, 0, 3, 3, 0,
               3, 3, 0, 0, 0, 0, 3, 3, 0,
               3, 3, 1, 0, 0, 1, 3, 3, 0,
               1, 3, 3, 3, 3, 3, 3, 1, 0,
               0, 1, 3, 3, 3, 3, 1, 0, 0 };
 
 
static char chr_Kx[99]={
               3, 3, 0, 0, 0, 0, 0, 3, 3,
               3, 3, 0, 0, 0, 0, 1, 3, 1,
               3, 3, 0, 0, 0, 1, 3, 1, 0,
               3, 3, 0, 0, 1, 3, 1, 0, 0,
               3, 3, 0, 1, 3, 1, 0, 0, 0,
               3, 3, 1, 3, 1, 0, 0, 0, 0,
               3, 3, 3, 1, 3, 1, 0, 0, 0,
               3, 3, 1, 0, 1, 3, 1, 0, 0,
               3, 3, 0, 0, 0, 1, 3, 1, 0,
               3, 3, 0, 0, 0, 0, 1, 3, 1,
               3, 3, 0, 0, 0, 0, 0, 3, 3 };
 
 
static char chr_Lx[99]={
               3, 3, 0, 0, 0, 0, 0, 0, 0,
               3, 3, 0, 0, 0, 0, 0, 0, 0,
               3, 3, 0, 0, 0, 0, 0, 0, 0,
               3, 3, 0, 0, 0, 0, 0, 0, 0,
               3, 3, 0, 0, 0, 0, 0, 0, 0,
               3, 3, 0, 0, 0, 0, 0, 0, 0,
               3, 3, 0, 0, 0, 0, 0, 0, 0,
               3, 3, 0, 0, 0, 0, 0, 0, 0,
               3, 3, 0, 0, 0, 0, 0, 0, 0,
               3, 3, 3, 3, 3, 3, 3, 3, 3,
               3, 3, 3, 3, 3, 3, 3, 3, 3 };
 
 
static char chr_Mx[99]={
               3, 3, 0, 0, 0, 0, 0, 3, 3,
               3, 3, 1, 0, 0, 0, 1, 3, 3,
               3, 3, 3, 0, 0, 0, 3, 3, 3,
               3, 3, 3, 1, 0, 2, 3, 3, 3,
               3, 3, 1, 1, 0, 1, 1, 3, 3,
               3, 3, 1, 3, 2, 3, 1, 3, 3,
               3, 3, 0, 3, 1, 3, 0, 3, 3,
               3, 3, 0, 1, 3, 1, 0, 3, 3,
               3, 3, 0, 0, 1, 0, 0, 3, 3,
               3, 3, 0, 0, 2, 0, 0, 3, 3,
               3, 3, 0, 0, 0, 0, 0, 3, 3 };
 
 
static char chr_Nx[99]={
               3, 3, 0, 0, 0, 0, 0, 3, 3,
               3, 3, 0, 0, 0, 0, 0, 3, 3,
               3, 3, 1, 0, 0, 0, 0, 3, 3,
               3, 3, 3, 1, 0, 0, 0, 3, 3,
               3, 3, 3, 3, 1, 2, 0, 3, 3,
               3, 3, 2, 3, 3, 3, 2, 3, 3,
               3, 3, 0, 2, 1, 3, 3, 3, 3,
               3, 3, 0, 0, 0, 1, 3, 3, 3,
               3, 3, 0, 0, 0, 0, 1, 3, 3,
               3, 3, 0, 0, 0, 0, 0, 3, 3,
               3, 3, 0, 0, 0, 0, 0, 3, 3 };

 
static char chr_Ox[99]={
               0, 0, 0, 1, 3, 1, 0, 0, 0,
               0, 0, 1, 3, 3, 3, 1, 0, 0,
               0, 1, 3, 3, 2, 3, 3, 1, 0,
               2, 3, 1, 0, 0, 0, 1, 3, 2,
               3, 3, 1, 0, 0, 0, 1, 3, 3,
               3, 3, 0, 0, 0, 0, 0, 3, 3,
               3, 3, 0, 0, 0, 0, 0, 3, 3,
               3, 3, 1, 0, 0, 0, 1, 3, 3,
               2, 3, 1, 0, 0, 0, 1, 3, 2,
               0, 1, 3, 3, 3, 3, 3, 1, 0,
               0, 0, 1, 3, 3, 3, 1, 0, 0 };
 
 
static char chr_Px[99]={
               3, 3, 3, 3, 3, 3, 1, 0, 0,
               3, 3, 3, 3, 3, 3, 3, 1, 0,
               3, 3, 0, 0, 0, 0, 1, 3, 1,
               3, 3, 0, 0, 0, 0, 0, 3, 3,
               3, 3, 0, 0, 0, 0, 0, 3, 3,
               3, 3, 0, 0, 0, 0, 1, 3, 1,
               3, 3, 3, 3, 3, 3, 3, 1, 0,
               3, 3, 3, 3, 3, 3, 1, 0, 0,
               3, 3, 0, 0, 0, 0, 0, 0, 0,
               3, 3, 0, 0, 0, 0, 0, 0, 0,
               3, 3, 0, 0, 0, 0, 0, 0, 0 };
 
 
static char chr_Qx[99]={
               0, 0, 0, 1, 3, 1, 0, 0, 0,
               0, 0, 1, 3, 3, 3, 1, 0, 0,
               0, 1, 3, 3, 2, 3, 3, 1, 0,
               2, 3, 1, 0, 0, 0, 1, 3, 2,
               3, 3, 1, 0, 0, 0, 1, 3, 3,
               3, 3, 0, 2, 1, 2, 0, 3, 3,
               3, 3, 2, 3, 3, 3, 2, 3, 3,
               3, 3, 1, 3, 3, 3, 1, 3, 3,
               2, 3, 3, 0, 0, 0, 3, 3, 2,
               0, 1, 3, 3, 3, 3, 3, 3, 3,
               0, 0, 1, 3, 3, 3, 1, 1, 3 };
 
 
static char chr_Rx[99]={
               3, 3, 3, 3, 3, 3, 1, 0, 0,
               3, 3, 3, 3, 3, 3, 3, 1, 0,
               3, 3, 0, 0, 0, 0, 1, 3, 1,
               3, 3, 0, 0, 0, 0, 0, 3, 3,
               3, 3, 0, 0, 0, 0, 1, 3, 1,
               3, 3, 3, 3, 3, 3, 3, 1, 0,
               3, 3, 3, 3, 3, 3, 1, 0, 0,
               3, 3, 0, 0, 0, 1, 3, 1, 0,
               3, 3, 0, 0, 0, 1, 3, 1, 0,
               3, 3, 0, 0, 0, 0, 1, 3, 3,
               3, 3, 0, 0, 0, 0, 0, 3, 3 };
 
 
static char chr_Sx[99]={
               0, 0, 1, 3, 3, 3, 1, 0, 0,
               0, 1, 3, 3, 3, 3, 3, 1, 0,
               1, 3, 1, 0, 0, 0, 1, 3, 1,
               1, 3, 1, 0, 0, 0, 0, 0, 0,
               0, 1, 3, 3, 1, 0, 0, 0, 0,
               0, 0, 1, 3, 3, 3, 1, 0, 0,
               0, 0, 0, 0, 1, 3, 3, 1, 0,
               3, 3, 0, 0, 0, 0, 1, 3, 1,
               1, 3, 1, 0, 0, 0, 1, 3, 1,
               0, 1, 3, 3, 3, 3, 3, 1, 0,
               0, 0, 1, 3, 3, 3, 1, 0, 0 };
 
 
static char chr_Tx[99]={
               0, 3, 3, 3, 3, 3, 3, 3, 3,
               0, 3, 3, 3, 3, 3, 3, 3, 3,
               0, 0, 0, 0, 3, 3, 0, 0, 0,
               0, 0, 0, 0, 3, 3, 0, 0, 0,
               0, 0, 0, 0, 3, 3, 0, 0, 0,
               0, 0, 0, 0, 3, 3, 0, 0, 0,
               0, 0, 0, 0, 3, 3, 0, 0, 0,
               0, 0, 0, 0, 3, 3, 0, 0, 0,
               0, 0, 0, 0, 3, 3, 0, 0, 0,
               0, 0, 0, 0, 3, 3, 0, 0, 0,
               0, 0, 0, 0, 3, 3, 0, 0, 0 };
 
 
static char chr_Ux[99]={
               3, 3, 0, 0, 0, 0, 0, 3, 3,
               3, 3, 0, 0, 0, 0, 0, 3, 3,
               3, 3, 0, 0, 0, 0, 0, 3, 3,
               3, 3, 0, 0, 0, 0, 0, 3, 3,
               3, 3, 0, 0, 0, 0, 0, 3, 3,
               3, 3, 0, 0, 0, 0, 0, 3, 3,
               3, 3, 0, 0, 0, 0, 0, 3, 3,
               3, 3, 0, 0, 0, 0, 0, 3, 3,
               3, 3, 1, 0, 0, 0, 1, 3, 3,
               0, 1, 3, 3, 3, 3, 3, 1, 0,
               0, 0, 1, 3, 3, 3, 1, 0, 0 };
 
 
static char chr_Vx[99]={
               3, 3, 0, 0, 0, 0, 0, 3, 3,
               3, 3, 0, 0, 0, 0, 0, 3, 3,
               1, 3, 2, 0, 0, 0, 2, 3, 1,
               1, 3, 1, 0, 0, 0, 1, 3, 1,
               1, 3, 3, 0, 0, 0, 3, 3, 1,
               0, 3, 3, 0, 0, 0, 3, 3, 0,
               0, 1, 3, 1, 0, 1, 3, 1, 0,
               0, 0, 3, 3, 0, 3, 3, 0, 0,
               0, 0, 1, 3, 1, 3, 1, 0, 0,
               0, 0, 0, 3, 3, 3, 0, 0, 0,
               0, 0, 0, 1, 3, 1, 0, 0, 0 };
 
 
static char chr_Wx[99]={
               3, 3, 0, 0, 0, 0, 0, 3, 3,
               3, 3, 0, 0, 0, 0, 0, 3, 3,
               3, 3, 0, 0, 2, 0, 0, 3, 3,
               3, 3, 0, 1, 2, 1, 0, 3, 3,
               3, 3, 0, 3, 1, 3, 0, 3, 3,
               3, 3, 0, 3, 3, 3, 0, 3, 3,
               1, 3, 1, 3, 1, 3, 1, 3, 1,
               2, 3, 3, 3, 2, 3, 3, 3, 2,
               0, 1, 3, 1, 0, 1, 3, 1, 0,
               0, 1, 3, 1, 0, 1, 3, 1, 0,
               0, 2, 1, 2, 0, 2, 1, 2, 0 };
 
 
static char chr_Xx[99]={
               3, 3, 0, 0, 0, 0, 0, 3, 3,
               3, 3, 0, 0, 0, 0, 0, 3, 3,
               1, 3, 1, 0, 0, 0, 1, 3, 1,
               0, 1, 3, 1, 0, 1, 3, 1, 0,
               0, 0, 1, 3, 1, 3, 1, 0, 0,
               0, 0, 0, 1, 3, 1, 0, 0, 0,
               0, 0, 1, 3, 1, 3, 1, 0, 0,
               0, 1, 3, 1, 0, 1, 3, 1, 0,
               1, 3, 1, 0, 0, 0, 1, 3, 1,
               3, 3, 0, 0, 0, 0, 0, 3, 3,
               3, 3, 0, 0, 0, 0, 0, 3, 3 };
 
 
static char chr_Yx[99]={
               3, 3, 0, 0, 0, 0, 0, 3, 3,
               3, 3, 0, 0, 0, 0, 0, 3, 3,
               1, 3, 1, 0, 0, 0, 0, 3, 3,
               1, 3, 1, 0, 0, 0, 1, 3, 1,
               0, 1, 3, 1, 0, 0, 1, 3, 1,
               0, 0, 1, 3, 1, 3, 1, 0, 0,
               0, 0, 2, 1, 3, 1, 2, 0, 0,
               0, 0, 0, 2, 3, 2, 0, 0, 0,
               0, 0, 0, 2, 3, 2, 0, 0, 0,
               0, 0, 0, 2, 3, 2, 0, 0, 0,
               0, 0, 0, 2, 3, 2, 0, 0, 0 };
 
 
static char chr_Zx[99]={
               3, 3, 3, 3, 3, 3, 3, 3, 3,
               3, 3, 3, 3, 3, 3, 3, 3, 3,
               0, 0, 0, 0, 0, 0, 3, 3, 1,
               0, 0, 2, 1, 0, 1, 3, 1, 0,
               0, 0, 1, 3, 1, 3, 1, 0, 0,
               0, 0, 0, 1, 3, 1, 0, 0, 0,
               0, 0, 1, 3, 1, 3, 1, 0, 0,
               0, 1, 3, 1, 0, 1, 2, 0, 0,
               1, 3, 3, 0, 0, 0, 0, 0, 0,
               3, 3, 3, 3, 3, 3, 3, 3, 3,
               3, 3, 3, 3, 3, 3, 3, 3, 3 };
 
 
static char chr_27x[99]={
               0, 0, 0, 2, 3, 3, 0, 0, 0,
               0, 0, 0, 2, 3, 3, 0, 0, 0,
               0, 0, 0, 2, 3, 3, 0, 0, 0,
               0, 0, 0, 0, 1, 3, 0, 0, 0,
               0, 0, 0, 1, 3, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0 };
 
 
static char chr_7cx[99]={
               0, 0, 0, 2, 3, 2, 0, 0, 0,
               0, 0, 0, 2, 3, 2, 0, 0, 0,
               0, 0, 0, 2, 3, 2, 0, 0, 0,
               0, 0, 0, 2, 3, 2, 0, 0, 0,
               0, 0, 0, 2, 3, 2, 0, 0, 0,
               0, 0, 0, 2, 3, 2, 0, 0, 0,
               0, 0, 0, 2, 3, 2, 0, 0, 0,
               0, 0, 0, 2, 3, 2, 0, 0, 0,
               0, 0, 0, 2, 3, 2, 0, 0, 0,
               0, 0, 0, 2, 3, 2, 0, 0, 0,
               0, 0, 0, 2, 3, 2, 0, 0, 0 };
 
 
static char chr_2ex[99]={
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 2, 3, 2, 0, 0, 0,
               0, 0, 0, 3, 3, 3, 0, 0, 0,
               0, 0, 0, 2, 3, 2, 0, 0, 0 };
 
 
static char chr_2cx[99]={
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 1, 3, 3, 0, 0, 0,
               0, 0, 0, 1, 3, 3, 0, 0, 0,
               0, 0, 0, 0, 3, 3, 0, 0, 0,
               0, 0, 0, 0, 1, 3, 0, 0, 0,
               0, 0, 0, 1, 3, 0, 0, 0, 0 };
 
 
static char chr_28x[99]={
               0, 0, 0, 0, 1, 3, 1, 0, 0,
               0, 0, 0, 1, 3, 1, 0, 0, 0,
               0, 0, 0, 1, 3, 0, 0, 0, 0,
               0, 0, 1, 3, 3, 0, 0, 0, 0,
               0, 0, 1, 3, 3, 0, 0, 0, 0,
               0, 0, 1, 3, 3, 0, 0, 0, 0,
               0, 0, 1, 3, 3, 0, 0, 0, 0,
               0, 0, 1, 3, 3, 0, 0, 0, 0,
               0, 0, 0, 1, 3, 0, 0, 0, 0,
               0, 0, 0, 1, 3, 1, 0, 0, 0,
               0, 0, 0, 0, 1, 3, 1, 0, 0 };
 
 
static char chr_29x[99]={
               0, 0, 1, 3, 1, 0, 0, 0, 0,
               0, 0, 0, 1, 3, 1, 0, 0, 0,
               0, 0, 0, 0, 3, 1, 0, 0, 0,
               0, 0, 0, 0, 3, 3, 1, 0, 0,
               0, 0, 0, 0, 3, 3, 1, 0, 0,
               0, 0, 0, 0, 3, 3, 1, 0, 0,
               0, 0, 0, 0, 3, 3, 1, 0, 0,
               0, 0, 0, 0, 3, 3, 1, 0, 0,
               0, 0, 0, 0, 3, 1, 0, 0, 0,
               0, 0, 0, 1, 3, 1, 0, 0, 0,
               0, 0, 1, 3, 1, 0, 0, 0, 0 };
 
   
static char chr_3fx[99]={
               0, 0, 1, 3, 3, 3, 1, 0, 0,
               0, 1, 3, 3, 3, 3, 3, 1, 0,
               0, 3, 3, 0, 0, 0, 3, 3, 0,
               0, 3, 3, 0, 0, 0, 3, 3, 0,
               0, 0, 0, 0, 1, 3, 3, 1, 0,
               0, 0, 0, 1, 3, 3, 1, 0, 0,
               0, 0, 0, 3, 3, 1, 0, 0, 0,
               0, 0, 0, 3, 3, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 3, 3, 0, 0, 0, 0,
               0, 0, 0, 3, 3, 0, 0, 0, 0 };
 
   
static char chr_5fx[99]={
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               3, 3, 3, 3, 3, 3, 3, 3, 3,
               3, 3, 3, 3, 3, 3, 3, 3, 3 };
 
   
static char chr_21x[99]={
               0, 0, 0, 0, 3, 3, 0, 0, 0,
               0, 0, 0, 2, 3, 3, 2, 0, 0,
               0, 0, 0, 2, 3, 3, 2, 0, 0,
               0, 0, 0, 2, 3, 3, 2, 0, 0,
               0, 0, 0, 2, 3, 3, 2, 0, 0,
               0, 0, 0, 0, 3, 3, 0, 0, 0,
               0, 0, 0, 0, 3, 3, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 3, 3, 0, 0, 0,
               0, 0, 0, 0, 3, 3, 0, 0, 0 };
 
   
static char chr_22x[99]={
               0, 0, 3, 3, 0, 3, 3, 0, 0,
               0, 0, 3, 3, 0, 3, 3, 0, 0,
               0, 0, 3, 3, 0, 3, 3, 0, 0,
               0, 0, 2, 2, 0, 2, 2, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0 };
 
   
static char chr_2dx[99]={
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               3, 3, 3, 3, 3, 3, 3, 3, 3,
               3, 3, 3, 3, 3, 3, 3, 3, 3,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0 };
 
   
static char chr_2bx[99]={
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 3, 3, 0, 0, 0,
               0, 0, 0, 0, 3, 3, 0, 0, 0,
               0, 0, 0, 0, 3, 3, 0, 0, 0,
               0, 3, 3, 3, 3, 3, 3, 3, 3,
               0, 3, 3, 3, 3, 3, 3, 3, 3,
               0, 0, 0, 0, 3, 3, 0, 0, 0,
               0, 0, 0, 0, 3, 3, 0, 0, 0,
               0, 0, 0, 0, 3, 3, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0 };
 
   
static char chr_10x[99]={
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 1, 3, 1, 0, 0, 0, 0,
               0, 0, 0, 1, 3, 1, 0, 0, 0,
               0, 0, 0, 0, 1, 3, 1, 0, 0,
               0, 0, 0, 0, 0, 1, 3, 1, 0,
               3, 3, 3, 3, 3, 3, 3, 3, 3,
               3, 3, 3, 3, 3, 3, 3, 3, 3,
               0, 0, 0, 0, 0, 1, 3, 1, 0,
               0, 0, 0, 0, 1, 3, 1, 0, 0,
               0, 0, 0, 1, 3, 1, 0, 0, 0,
               0, 0, 1, 3, 1, 0, 0, 0, 0 };
 
   
static char chr_11x[99]={
               0, 0, 0, 2, 3, 2, 0, 0, 0,
               0, 0, 0, 2, 3, 2, 0, 0, 0,
               3, 3, 0, 2, 3, 2, 0, 3, 3,
               3, 3, 0, 2, 3, 2, 0, 3, 3,
               3, 3, 0, 2, 3, 2, 0, 3, 3,
               1, 3, 2, 2, 3, 2, 2, 3, 1,
               1, 3, 2, 2, 3, 2, 2, 3, 1,
               0, 3, 1, 2, 3, 2, 1, 3, 0,
               0, 1, 3, 3, 3, 3, 3, 1, 0,
               0, 0, 2, 3, 3, 3, 2, 0, 0,
               0, 0, 0, 2, 3, 2, 0, 0, 0 };
 
   
static char chr_3ax[99]={
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 3, 3, 3, 0, 0, 0,
               0, 0, 0, 3, 3, 3, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 3, 3, 3, 0, 0, 0,
               0, 0, 0, 3, 3, 3, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0,
               0, 0, 0, 0, 0, 0, 0, 0, 0 };
 
static char chr_19x[99]={
               2, 2, 2, 2, 2, 2, 2, 2, 2,
               2, 2, 2, 2, 2, 2, 2, 2, 2,
               2, 2, 2, 2, 2, 2, 2, 2, 2,
               2, 2, 2, 2, 2, 2, 2, 2, 2,
               2, 2, 2, 2, 2, 2, 2, 2, 2,
               2, 2, 2, 2, 2, 2, 2, 2, 2,
               2, 2, 2, 2, 2, 2, 2, 2, 2,
               2, 2, 2, 2, 2, 2, 2, 2, 2,
               2, 2, 2, 2, 2, 2, 2, 2, 2,
               2, 2, 2, 2, 2, 2, 2, 2, 2,
               2, 2, 2, 2, 2, 2, 2, 2, 2 };
 

int rr,sq;

int main( int argc, char *argv[] )
{
 
   int si,cc,dd1,dd2,i,j;
   unsigned char kcrgb[5]=".cl",arg[20],*arx;
   FILE *fp,*ft;

   argc1=argc;
   st1=gettime();
   first();
/*
   for(i=0;i<max;i++){
      for(j=0;j<NARABI;j++){
         it[i][j]=0;
         iy[i][j]=0;
         ht[i][j]=0;
         hy[i][j]=0;
      }
   }
 */
   if(argc<2){
      cl_open1(test_cl);
   }
   else{
      si=0;
      arx=argv[1];
      while(*arx != '\0' && *arx != '.' && si<8){
         arg[si] = *arx;
         arx++;
         si++;
      }
      arg[si]='\0';
      strcpy(ar2,arg);
      strcat(arg,kcrgb);
      cl_open1(arg);
      
   }
  
   ktymax();
   kk=max11(tatemax,yokomax);
/*
   if(yokomax<=10 && tatemax<=20){
      dot1=25;
      dot2=24;
   }
   else{
      dd1=490/yokomax;
      dd2=940/tatemax;
      dd1=min11(dd1,dd2);
      dot1=dd1;
      dot2=dd1-1;
      /*if(dot2<28) dot2=dot1;*/
/*
      ktmax=kymax=0;
    }
*/
 
   if(argc<2) chz(70, 8,test_cl,4);
   else       chz(70, 8,arg,4);
  
   chz(20,8,"FILE:",4);
   chz(300,8,"TITLE:",5);
   chz(350, 8,msg,2);

   for(i=1;i<=20&&i<=tatemax;i++){
      for(j=1;j<=it[i][KKK];j++){
          chc(i*T35+7+3,(j-it[i][KKK])*T18+454-3,it[i][j]/SK);
          chx(i*T35+7+3,(j-it[i][KKK])*T18+454-3,i%5+21);
          pr_10x3(it[i][j]%SK,i*T35+38+3,(j-it[i][KKK])*T18+450-3,30);
      }
      chc(i*T35+10,514,22);
      chx(i*T35+10,514,i%5+21);
      pr_10x3(i,i*T35+38,510,30);
      chset2(i*T35+30,470,0x7c,i%5+8);
      chset2(i*T35+30,480,0x7c,i%5+8);
      chset2(i*T35+30,490,0x11,i%5+8);
   }

   while(1){
      hantei();
   }
}
 
int asc11(char a){
   if('0'<=a&&a<='9') return a-'0';
   else if('A'<=a&&a<='F') return a-'A'+10;
   else if('a'<=a&&a<='f') return a-'a'+10;
}

double gettime(){
   struct timeval tv;
   gettimeofday(&tv,NULL);
   return tv.tv_sec+(double)tv.tv_usec*1e-6;
}
static char chr_1[15]={
               0, 2, 0,
               2, 2, 0,
               0, 2, 0,
               0, 2, 0,
               0, 2, 0  };

static char chr_2[15]={
               2, 2, 2,
               0, 0, 2,
               2, 2, 2,
               2, 0, 0,
               2, 2, 2  };

static char chr_3[15]={
               2, 2, 2,
               0, 0, 2,
               2, 2, 2,
               0, 0, 2,
               2, 2, 2  };

static char chr_4[15]={
               2, 0, 2,
               2, 0, 2,
               2, 2, 2,
               0, 0, 2,
               0, 0, 2  };

static char chr_5[15]={
               2, 2, 2,
               2, 0, 0,
               2, 2, 2,
               0, 0, 2,
               2, 2, 2  };

static char chr_6[15]={
               2, 2, 2,
               2, 0, 0,
               2, 2, 2,
               2, 0, 2,
               2, 2, 2  };

static char chr_7[15]={
               2, 2, 2,
               2, 0, 2,
               0, 0, 2,
               0, 0, 2,
               0, 0, 2  };

static char chr_8[15]={
               2, 2, 2,
               2, 0, 2,
               2, 2, 2,
               2, 0, 2,
               2, 2, 2  };

static char chr_9[15]={
               2, 2, 2,
               2, 0, 2,
               2, 2, 2,
               0, 0, 2,
               2, 2, 2  };

static char chr_0[15]={
               2, 2, 2,
               2, 0, 2,
               2, 0, 2,
               2, 0, 2,
               2, 2, 2  };


void g_dot(int x, int y){
  XDrawLine(dpy,win,gc,x,y,x,y);
  XFlush(dpy);
}

void g_text(int x, int y,char *str){
  XDrawString(dpy,win,gc,x,y,str,strlen(str));
  XFlush(dpy);
}

void g_line(int x0, int y0, int x1, int y1){
  XDrawLine(dpy,win,gc,x0,y0,x1,y1);
  XFlush(dpy);
}

void g_rgb(long iro){
  XColor xc;

  xc.red = (iro&0xff0000)/256;
  xc.green = (iro&0x00ff00); 
  xc.blue = (iro&0x0000ff)*256;
  XAllocColor(dpy,DefaultColormap(dpy,screen),&xc);
  XSetForeground(dpy,gc,xc.pixel);
  XFlush(dpy);
}

void g_fill(int x0,int y0, int wid, int hei){
  XFillRectangle(dpy,win,gc,x0,y0,wid, hei);
  XFlush(dpy);
}

void g_box(int x0, int y0, int wid, int hei){
  XDrawRectangle(dpy,win,gc,x0,y0,wid, hei);
  XFlush(dpy);
}

void g_clear(){
  g_rgb(0xffffff);
  XFillRectangle(dpy,win,gc,0,0,win_width, win_height);  
  g_rgb(0x000000);
  XFlush(dpy);
}

void first(){
 
   dpy = XOpenDisplay( NULL );    /* Xサーバに接続する */
   screen = DefaultScreen( dpy ); /* スクリーン設定 */
   win = XCreateSimpleWindow(     /* ウィンドウを開く */
         dpy,                     /* Xサーバ */
         RootWindow(dpy,screen),  /* 親ウィンドウ */
         0, 0,                    /* 表示時の左上隅の座標 x, y */
         win_width, win_height,   /* ウィンドウの幅と高さ */
         1, BlackPixel(dpy,screen),/* ボーダーの幅と色 */
         WhitePixel(dpy,screen)    /* ウィンドウの背景色 */
        );
   XSelectInput( dpy, win, ExposureMask|KeyPressMask|StructureNotifyMask);
   XMapWindow( dpy, win );  /* ウィンドウのマッピング */
 
   gc = DefaultGC( dpy, screen ); /* グラフィックコンテキストの設定 */
   XSetForeground( dpy, gc, BlackPixel(dpy,screen) ); /* 描画色設定 */
 
   atom1 = XInternAtom( dpy, "WM_PROTOCOLS", False );
   atom2 = XInternAtom( dpy, "WM_DELETE_WINDOW", False );
   XSetWMProtocols( dpy, win, &atom2, 1 );
}

void hantei(){
   int i,j;

     XNextEvent( dpy, &event );
     switch( event.type ){
     case Expose:
/*       XDrawLine( dpy, win, gc, 0, 0, win_width, win_height ); /* 線を描く */
/*       XFlush( dpy );  /* バッファのフラッシュ */
       break;
     case ConfigureNotify:
       XGetGeometry( dpy, win, &root,
               &dummy, &dummy, &win_width, &win_height,
               &dummy, &dummy );
/*       XDrawLine( dpy, win, gc, 0, 0, win_width, win_height ); /* 線を描く */
/*       XFlush( dpy );  /* バッファのフラッシュ */
       break;
     case KeyPress:
       key_sym = XKeycodeToKeysym( dpy, event.xkey.keycode, 0 );
       if( key_sym == XK_Escape ){
         XDestroyWindow( dpy, win );
       }
       if( key_sym == XK_Up ){
         XDestroyWindow( dpy, win );
       }
       if( key_sym == XK_Down ){
         XDestroyWindow( dpy, win );
       }
       if( key_sym == XK_Right ){
         XDestroyWindow( dpy, win );
       }
       if( key_sym == XK_Left ){
         XDestroyWindow( dpy, win );
       }
        if(0x20<=key_sym&&key_sym <= 0x7f){
            for(i=1;i<=tatemax;i++){
                for(j=1;j<=yokomax;j++){
                   if(data[i][j] == 100) box( (kymax+i)*dot1+20,(ktmax+j)*dot1+30,dot2,5);
                   if(data[i][j] == 200) box( (kymax+i)*dot1+20,(ktmax+j)*dot1+30,dot2,6);
                }
             }
       }
       if( key_sym == 'q' ){
         XDestroyWindow( dpy, win );
       }
      break;
     case ClientMessage:
       if( event.xclient.message_type == atom1 &&
         event.xclient.data.l[0] == atom2 ){
         XDestroyWindow( dpy, win );
       }
       break;
     case DestroyNotify:
       XCloseDisplay( dpy );
       exit(0);
       break;
     default:
       ;
     }
}

 
void ktymax(){

   int i;

   ktmax=1;
   for(i=1;i<=tatemax;i++){
      ktmax=max11(it[i][KKK],ktmax);
   }
   kymax=1;
   for(i=1;i<=yokomax;i++){
      kymax=max11(iy[i][KKK],kymax);
   }

}

int fincount(){

   int i,ret;

   scount=ret=0;
   for(i=1;i<=tatemax;i++){
      if(it[i][KFIN] == 100){ scount++;
         /*box((kymax+i)*dot1+dot1/2+17,(ktmax+yokomax+2)*dot1+dot1/2+27,5,9);*/
      }
   }
   for(i=1;i<=yokomax;i++){
      if(iy[i][KFIN] == 100){ scount++;
         /*box((kymax+tatemax+2)*dot1+dot1/2+17,(ktmax+i)*dot1+dot1/2+27,5,9);*/
       }
   }
   if(scount == tatemax+yokomax)  ret=1;

   return ret;
}

 
 
void intro(){

   int i,j,k;

   for(i=1;i<=tatemax;i++){
      for(j=1;j<=yokomax;j++){
         data[i][j]=0;
      }
   }

   for(i=1;i<=tatemax;i++){
      it[i][KSTART]=1;
      it[i][KEND]=it[i][KKK];
   }
   for(i=1;i<=yokomax;i++){
      iy[i][KSTART]=1;
      iy[i][KEND]=iy[i][KKK];
   }

}

 
void cl_open1(char *file){

   int i=0,j=0,k=0;
   int xx=0,y=0,mtype=0,uti=0,fhajime=0;
   int tt=0,yy=0,m=0,ccount;
   int n,cln,cl2;
   char cldata[10];

   FILE *fpin;
   char c;

   

   fpin = fopen(file,"r");
   if(fpin==0){
      printf("ファイル名が %s やて？　そんなのあらへんで\n\n",file);
      exit(0);
   }
   c=fgetc(fpin);

   j=1;
   ex1=0;
   while(c != EOF){
      mtype=0;
      fhajime=0;
      y=0;
      m=0;
      k=1;
      i=0;
      while(c != '\n'){
         if(i==0){
            if(c == '*' ){
               c=fgetc(fpin);
               if(     c == 'T'){   mtype=1; uti=1;  i++;  }
               else if(c == 'Y'){   mtype=1; uti=2;  i++;  }
               else if(c == 't'){   mtype=1; uti=3;  i++;  }
               else if(c == 'y'){   mtype=1; uti=4;  i++;  }
               else if(c == 'S'){   mtype=1; uti=10; i++;  }
               else if(c == 's'){   mtype=1; uti=10; i++;  }
               else if(c == 'R'){   mtype=1; uti=15; i++;  }
               else if(c == 'r'){   mtype=1; uti=15; i++;  }
               else if(c == 'K'){   mtype=1; uti=20; i++;  }
               else if(c == 'k'){   mtype=1; uti=20; i++;  }
               else if(c == 'D'){   mtype=1; uti=25; i++;  }
               else if(c == 'd'){   mtype=1; uti=25; i++;  }
               else if(c == 'L'){   mtype=1; uti=30; i++;  }
               else if(c == 'l'){   mtype=1; uti=30; i++;  }
               else if(c == 'Z'){   mtype=1; uti=35; i++; ex1++; }
               else if(c == 'z'){   mtype=1; uti=35; i++; ex1++; }
               else if(c == 'X'){   mtype=3; i++; }
               else if(c == 'x'){   mtype=3; i++; }
               else if(c == 'M'){   mtype=45;        i++;  }
               else if(c == 'm'){   mtype=45;        i++;  }
               else{
                  printf("何かおかしいんと、ちゃいまっか");
                  printf(" %d 行の２文字目が %c \n",j,c);
                  exit(0);
               }
            }
            else if(c == ';'){  mtype=99; i++;   }
            else if(c == ' '){  mtype=99; i++;   }
            else{
               printf("何かおかしいんと、ちゃいまっか");
               printf(" %d 行の１文字目が %c \n",j,c);
               exit(0);
            }
         }
         else{
            if(mtype==45){
               msg[m]=c;
               m++;
            }
            if(c == ' ' && mtype==1 && fhajime==0){
               ccount=0;
               cl2=888;
               if(uti==1){ tatemax=xx; }
               if(uti==2){ yokomax=xx; }
               if(uti==10){
                  if(0<= xx && xx <=9) sl=xx;
                  else                 sl=6;
               }
               if(uti==15){
                  if(xx == 1) trace=1;
                  else        trace=0;
               }
               if(uti==20){
                  if(0<= xx && xx < 80) kdata=xx;
                  else                  kdata=80;
               }
               if(uti==25){
                  if(0<= xx && xx < 80) speed=xx;
                  else                  speed=2;
               }
               if(uti==30){
                  if(0<= xx && xx < 220) length=xx;
                  else                   length=220;
               }
               if(uti==35){
		  exx[ex1]=xx; xx=0; y=0;	/*	printf("4 %d, %d, %d, %d,%s\n",ex1,exx[ex1],exy[ex1],exz[ex1],cldata); */

               }
               if(uti==3){
                  if(xx==1){ tt=1; }
                  else{
                     tt++;
                     if(tt != xx){
                        printf("順序がちゃう縦 %d 行\n",tt);
                        exit(0);
                     }
                  }
                  y=0;
               }
               if(uti==4){
                  if(xx==1){ yy=1; }
                  else{
                     yy++;
                     if(yy != xx){
                        printf("順序がちゃう横 %d 行\n",yy);
                        exit(0);
                     }
                  }
                  y=0;
               }

               fhajime=1;
            }
            if((c == ','|| c == '.') && mtype==1 && fhajime==1){
               if(strcmp(cldata,"")==0) cln=cl2;

               if(y==0 && uti==3){
                  printf("カンマが多いで 縦 %d 行",tt);
                  exit(0);
               }
               if(y==0 && uti==4){
                  printf("カンマが多いで 横 %d 行",yy);
                  exit(0);
               }

               if(cln==888 && uti==3){
                  printf("最初に色を教えてヤ 縦 %d 行",tt);
                  exit(0);
               }
               if(cln==888 && uti==4){
                  printf("最初に色を教えてヤ 横 %d 行",yy);
                  exit(0);
               }

               if(     uti==3){ it[tt][k]=cln*SK+xx; y=0; }
               else if(uti==4){ iy[yy][k]=cln*SK+xx; y=0; }
               else if(uti==35){ exx[ex1]=xx; xx=0; y=0;	/*	printf("2 %d, %d, %d, %d,%s\n",ex1,exx[ex1],exy[ex1],exz[ex1],cldata); */
 }
               k++;
            }
            if(c == ' ' && mtype==1 && fhajime==1){
               cldata[ccount]='\0';
            }
            if(c == '=' && mtype==1 && fhajime==1){
               cldata[ccount]='\0';
               ccount=0;
               cln=999;
               for(n=0;n<16;n++){
                  if(strcmp(cldata,cltable[n])==0) cln=n;
               }
               if(cln==999 && uti==3){
                  printf("その色はアカン 縦 %d 行",tt);
                  exit(0);
               }
               if(cln==999 && uti==4){
                  printf("その色はアカン 横 %d 行",yy);
                  exit(0);
               }
               if(cln==999 && uti==35){
                  printf("その色はアカン 35 %d 行",yy);
                  exit(0);
               }
               cl2=cln;
            }
            if('0' <= c && c <= '9' && mtype==1){ 
               xx=c-'0'+y*10;
               y=xx;
            }
            if('a' <= c && c <= 'z' && mtype==1){ 
               cldata[ccount]=c;
               ccount++;
            }
         }
         c=fgetc(fpin);
      }
      /* if(mtype==99){} */
      if(mtype==45){
       }
      if(mtype==1 ){
         if(fhajime==0){
            if(uti==1){  tatemax=xx; }
            if(uti==2){  yokomax=xx; }
            if(uti==10){ 
               if(0<= xx && xx <=9) sl=xx;
               else                 sl=6;
            }
            if(uti==15){
               if(xx == 1) trace=1;
               else        trace=0;
            }
            if(uti==20){
               if(0<= xx && xx < 80) kdata=xx;
               else                  kdata=80;
            }
            if(uti==25){
               if(0<= xx && xx < 80) speed=xx;
               else                  speed=2;
            }
            if(uti==30){
               if(0<= xx && xx < 220) length=xx;
               else                   length=220;
            }
         }
         if(fhajime==1){
            if(uti==3){
               it[tt][k]=cln*SK+xx;
               it[tt][KKK]=k;
            }
            else if(uti==4){ 
               iy[yy][k]=cln*SK+xx;
               iy[yy][KKK]=k;
            }
            else if(uti==35){ 
 	        exy[ex1]=xx;
	   	exz[ex1]=cln;
		/*printf("1 %d, %d, %d, %d,%s\n",ex1,exx[ex1],exy[ex1],exz[ex1],cldata); */
            }
            else{
               printf("DATAが入ってないで：ファイル %s の %d 行\n",file,j);
               exit(0);
            }
         }
      }
      c=fgetc(fpin);
      j++;
   }
   fclose(fpin);
}

 
int max11(int a,int b){

   if(a<=b) return b;
   else     return a;
}

int min11(int a,int b){

   if(a<=b) return a;
   else     return b;

}

 

void a_write1(int a,int b,unsigned char *c,int ss)
{
   int s,t,u=0;

   for(s=0;s<5;s++){
       for(t=0;t<3;t++){
           if(*(c+u) != 0)  box(a+t*2,b+s*2,2,ss); 
       /*    else             box(a+t*2,b+s*2,2,0 ); */ 
           u++;
       }
   }

}

void chset1(int a, int b,int c,int ss)
{
   if(c==1) a_write1(a,b,chr_1, ss);
   if(c==2) a_write1(a,b,chr_2, ss);
   if(c==3) a_write1(a,b,chr_3, ss);
   if(c==4) a_write1(a,b,chr_4, ss);
   if(c==5) a_write1(a,b,chr_5, ss);
   if(c==6) a_write1(a,b,chr_6, ss);
   if(c==7) a_write1(a,b,chr_7, ss);
   if(c==8) a_write1(a,b,chr_8, ss);
   if(c==9) a_write1(a,b,chr_9, ss);
   if(c==0) a_write1(a,b,chr_0, ss);

}

void pr_10x(int suu,int x,int y,int col)
{
   int l=0;
   int su2;

   if(suu==0)   chset1( x-l*8,y,0,col);
   
   while(suu != 0){
      su2=suu%10;
      chset1(x-l*8,y,su2,col);
      suu=suu/10;
      l++;
   }

}

void box(x1,y1,fu,iro)
int x1,y1,fu,iro;
{
    /* 120515 */
    if(iro==0){g_rgb(0x000000);}
    else if(iro==1){g_rgb(0xf00000);}
    else if(iro==2){g_rgb(0x00f000);}
    else if(iro==3){g_rgb(0x0000f0);}
    else if(iro==4){g_rgb(0xf0f000);}
    else if(iro==5){g_rgb(0xbb00bb);}
    else if(iro==6){g_rgb(0x00f0f0);}
    else if(iro==7){g_rgb(0xffffff);}
    else if(iro==8){g_rgb(0xff9010);}
    else if(iro==9){g_rgb(0xc04040);}
    else if(iro==10){g_rgb(0xff1493);}
    else if(iro==11){g_rgb(0xffaa88);}
    else if(iro==12){g_rgb(0xc0f000);}
    else if(iro==13){g_rgb(0xb8860b);}
    else if(iro==14){g_rgb(0x4b0082);}
    else if(iro==15){g_rgb(0xa0a0a0);}
    else{g_rgb(0xeeeeee);}

    g_fill(x1,y1,fu,fu);
}

void errorbox(x1,y1,fu)
int x1,y1,fu;
{
   int ff;

   ff=fu/2;
   box(x1   ,y1   ,ff, 9);
   box(x1+ff,y1   ,ff, 9);
   box(x1   ,y1+ff,ff, 9);
   box(x1+ff,y1+ff,ff, 9);

}

 
void a_write2(int a,int b,unsigned char *c,int ss)
{
   int s,t,u=0;

   for(s=0;s<11;s++){
       for(t=0;t<9;t++){
           if(*(c+u) == 4)  box2(a+t,b+s,1,0); 
           if(*(c+u) == 3)  box2(a+t,b+s,1,ss); 
           if(*(c+u) == 1)  box2(a+t,b+s,1,ss+30); 
           if(*(c+u) == 2)  box2(a+t,b+s,1,ss+60); 
       /*    else             box(a+t*2,b+s*2,2,0 ); */ 
           u++;
       }
   }

}
 

void chz(int a, int b,char *p,int ss)
{
   int l=0;

   while(*p!='\0'){
      chset2(a+l*10,b,*p,ss);
      l++;
      p++;
   }
}


void chset2(int a, int b,int c,int ss)
{
   if(c=='1') a_write2(a,b,chr_1x, ss);
   if(c=='2') a_write2(a,b,chr_2x, ss);
   if(c=='3') a_write2(a,b,chr_3x, ss);
   if(c=='4') a_write2(a,b,chr_4x, ss);
   if(c=='5') a_write2(a,b,chr_5x, ss);
   if(c=='6') a_write2(a,b,chr_6x, ss);
   if(c=='7') a_write2(a,b,chr_7x, ss);
   if(c=='8') a_write2(a,b,chr_8x, ss);
   if(c=='9') a_write2(a,b,chr_9x, ss);
   if(c=='0') a_write2(a,b,chr_0x, ss);

   if(c=='a') a_write2(a,b,chr_ax, ss);
   if(c=='b') a_write2(a,b,chr_bx, ss);
   if(c=='c') a_write2(a,b,chr_cx, ss);
   if(c=='d') a_write2(a,b,chr_dx, ss);
   if(c=='e') a_write2(a,b,chr_ex, ss);
   if(c=='f') a_write2(a,b,chr_fx, ss);
   if(c=='g') a_write2(a,b,chr_gx, ss);
   if(c=='h') a_write2(a,b,chr_hx, ss);
   if(c=='i') a_write2(a,b,chr_ix, ss);
   if(c=='j') a_write2(a,b,chr_jx, ss);
   if(c=='k') a_write2(a,b,chr_kx, ss);
   if(c=='l') a_write2(a,b,chr_lx, ss);
   if(c=='m') a_write2(a,b,chr_mx, ss);
   if(c=='n') a_write2(a,b,chr_nx, ss);
   if(c=='o') a_write2(a,b,chr_ox, ss);
   if(c=='p') a_write2(a,b,chr_px, ss);
   if(c=='q') a_write2(a,b,chr_qx, ss);
   if(c=='r') a_write2(a,b,chr_rx, ss);
   if(c=='s') a_write2(a,b,chr_sx, ss);
   if(c=='t') a_write2(a,b,chr_tx, ss);
   if(c=='u') a_write2(a,b,chr_ux, ss);
   if(c=='v') a_write2(a,b,chr_vx, ss);
   if(c=='w') a_write2(a,b,chr_wx, ss);
   if(c=='x') a_write2(a,b,chr_xx, ss);
   if(c=='y') a_write2(a,b,chr_yx, ss);
   if(c=='z') a_write2(a,b,chr_zx, ss);

   if(c=='A') a_write2(a,b,chr_Ax, ss);
   if(c=='B') a_write2(a,b,chr_Bx, ss);
   if(c=='C') a_write2(a,b,chr_Cx, ss);
   if(c=='D') a_write2(a,b,chr_Dx, ss);
   if(c=='E') a_write2(a,b,chr_Ex, ss);
   if(c=='F') a_write2(a,b,chr_Fx, ss);
   if(c=='G') a_write2(a,b,chr_Gx, ss);
   if(c=='H') a_write2(a,b,chr_Hx, ss);
   if(c=='I') a_write2(a,b,chr_Ix, ss);
   if(c=='J') a_write2(a,b,chr_Jx, ss);
   if(c=='K') a_write2(a,b,chr_Kx, ss);
   if(c=='L') a_write2(a,b,chr_Lx, ss);
   if(c=='M') a_write2(a,b,chr_Mx, ss);
   if(c=='N') a_write2(a,b,chr_Nx, ss);
   if(c=='O') a_write2(a,b,chr_Ox, ss);
   if(c=='P') a_write2(a,b,chr_Px, ss);
   if(c=='Q') a_write2(a,b,chr_Qx, ss);
   if(c=='R') a_write2(a,b,chr_Rx, ss);
   if(c=='S') a_write2(a,b,chr_Sx, ss);
   if(c=='T') a_write2(a,b,chr_Tx, ss);
   if(c=='U') a_write2(a,b,chr_Ux, ss);
   if(c=='V') a_write2(a,b,chr_Vx, ss);
   if(c=='W') a_write2(a,b,chr_Wx, ss);
   if(c=='X') a_write2(a,b,chr_Xx, ss);
   if(c=='Y') a_write2(a,b,chr_Yx, ss);
   if(c=='Z') a_write2(a,b,chr_Zx, ss);

   if(c==0x2e) a_write2(a,b,chr_2ex, ss);
   if(c==0x2c) a_write2(a,b,chr_2cx, ss);
   if(c==0x28) a_write2(a,b,chr_28x, ss);
   if(c==0x29) a_write2(a,b,chr_29x, ss);
   if(c==0x3f) a_write2(a,b,chr_3fx, ss);
   if(c==0x5f) a_write2(a,b,chr_5fx, ss);
   if(c==0x7c) a_write2(a,b,chr_7cx, ss);
   if(c==0x21) a_write2(a,b,chr_21x, ss);
   if(c==0x22) a_write2(a,b,chr_22x, ss);
   if(c==0x27) a_write2(a,b,chr_27x, ss);
   if(c==0x2d) a_write2(a,b,chr_2dx, ss);
   if(c==0x2b) a_write2(a,b,chr_2bx, ss);
   if(c==0x10) a_write2(a,b,chr_10x, ss);
   if(c==0x11) a_write2(a,b,chr_11x, ss);
   if(c==0x3a) a_write2(a,b,chr_3ax, ss);
   if(c==0x19) a_write2(a,b,chr_19x, ss);
 
}
void pr_10x2(int suu,int x,int y,int col)
{
   int l=0;
   int su2;

   if(suu==0)   chset2( x-l*10,y,'0',col);
   
   while(suu != 0){
      su2=suu%10;
      chset2(x-l*10,y,su2+'0',col);
      /*printf("%d\n",x-l*6);*/
      suu=suu/10;
      l++;
   }

}

void box2(x1,y1,fu,iro)
int x1,y1,fu,iro;
{
    if(iro==0){g_rgb(0x000000);}

    else if(iro== 1){g_rgb(0xaa2222);}
    else if(iro== 2){g_rgb(0x22aa22);}
    else if(iro== 3){g_rgb(0x2222aa);}
    else if(iro== 4){g_rgb(0xaaaa22);}
    else if(iro== 5){g_rgb(0x22aaaa);}

    else if(iro== 6){g_rgb(0xaa22aa);}
    else if(iro== 7){g_rgb(0xaaaaaa);}
    else if(iro== 8){g_rgb(0x772222);}
    else if(iro== 9){g_rgb(0x227722);}
    else if(iro==10){g_rgb(0x222277);}

    else if(iro==11){g_rgb(0x777722);}
    else if(iro==12){g_rgb(0x227777);}
    else if(iro==13){g_rgb(0x772277);}
    else if(iro==14){g_rgb(0x777777);}
    else if(iro==15){g_rgb(0xaa7722);}

    else if(iro==16){g_rgb(0x77aa22);}
    else if(iro==17){g_rgb(0x22aa77);}
    else if(iro==18){g_rgb(0x2277aa);}
    else if(iro==19){g_rgb(0x7722aa);}
    else if(iro==20){g_rgb(0xaa2277);}

    else if(iro==21){g_rgb(0x77aaaa);}
    else if(iro==22){g_rgb(0xaa77aa);}
    else if(iro==23){g_rgb(0xaaaa77);}
    else if(iro==24){g_rgb(0x7777aa);}
    else if(iro==25){g_rgb(0x77aa77);}

    else if(iro==26){g_rgb(0x7777aa);}
    else if(iro==27){g_rgb(0xaa2222);}
    else if(iro==28){g_rgb(0x22aa22);}
    else if(iro==29){g_rgb(0x2222aa);}
    else if(iro==30){g_rgb(0xffffff);}


    else if(iro==31){g_rgb(0xcc7777);}
    else if(iro==32){g_rgb(0x77cc77);}
    else if(iro==33){g_rgb(0x7777cc);}
    else if(iro==34){g_rgb(0xcccc77);}
    else if(iro==35){g_rgb(0x77cccc);}

    else if(iro==36){g_rgb(0xcc77cc);}
    else if(iro==37){g_rgb(0xcccccc);}
    else if(iro==38){g_rgb(0xaa7777);}
    else if(iro==39){g_rgb(0x77aa77);}
    else if(iro==40){g_rgb(0x7777aa);}

    else if(iro==41){g_rgb(0xaaaa77);}
    else if(iro==42){g_rgb(0x77aaaa);}
    else if(iro==43){g_rgb(0xaa77aa);}
    else if(iro==44){g_rgb(0xaaaaaa);}
    else if(iro==45){g_rgb(0xccaa77);}

    else if(iro==46){g_rgb(0xaacc77);}
    else if(iro==47){g_rgb(0x77ccaa);}
    else if(iro==48){g_rgb(0x77aacc);}
    else if(iro==49){g_rgb(0xaa77cc);}
    else if(iro==50){g_rgb(0xcc77aa);}

    else if(iro==51){g_rgb(0xaacccc);}
    else if(iro==52){g_rgb(0xccaacc);}
    else if(iro==53){g_rgb(0xccccaa);}
    else if(iro==54){g_rgb(0xaaaacc);}
    else if(iro==55){g_rgb(0xaaccaa);}

    else if(iro==56){g_rgb(0xaaaacc);}
    else if(iro==57){g_rgb(0xcc7777);}
    else if(iro==58){g_rgb(0x77cc77);}
    else if(iro==59){g_rgb(0x7777cc);}
    else if(iro==60){g_rgb(0xffffff);}

 
    else if(iro==61){g_rgb(0xeebbbb);}
    else if(iro==62){g_rgb(0xbbeebb);}
    else if(iro==63){g_rgb(0xbbbbee);}
    else if(iro==64){g_rgb(0xeeeebb);}
    else if(iro==65){g_rgb(0xbbeeee);}

    else if(iro==66){g_rgb(0xeebbee);}
    else if(iro==67){g_rgb(0xeeeeee);}
    else if(iro==68){g_rgb(0xddbbbb);}
    else if(iro==69){g_rgb(0xbbddbb);}
    else if(iro==70){g_rgb(0xbbbbdd);}

    else if(iro==71){g_rgb(0xddddbb);}
    else if(iro==72){g_rgb(0xbbdddd);}
    else if(iro==73){g_rgb(0xddbbdd);}
    else if(iro==74){g_rgb(0xdddddd);}
    else if(iro==75){g_rgb(0xeeddbb);}

    else if(iro==76){g_rgb(0xddeebb);}
    else if(iro==77){g_rgb(0xbbeedd);}
    else if(iro==78){g_rgb(0xbbddee);}
    else if(iro==79){g_rgb(0xddbbee);}
    else if(iro==80){g_rgb(0xeebbdd);}

    else if(iro==81){g_rgb(0xddeeee);}
    else if(iro==82){g_rgb(0xeeddee);}
    else if(iro==83){g_rgb(0xeeeedd);}
    else if(iro==84){g_rgb(0xddddee);}
    else if(iro==85){g_rgb(0xddeedd);}

    else if(iro==86){g_rgb(0xddddee);}
    else if(iro==87){g_rgb(0xeebbbb);}
    else if(iro==88){g_rgb(0xbbeebb);}
    else if(iro==89){g_rgb(0xbbbbee);}
    else if(iro==90){g_rgb(0xffffff);}
  
    else{g_rgb(0x888888);}

    g_fill(x1,y1,fu,fu);
}

void pr_10x3(int suu,int x,int y,int col)
{
   int l=0;
   int su2;

   if(suu==0)   chset3( x-l*14,y,'0',col);
   
   while(suu != 0){
      su2=suu%10;
      chset3(x-l*14,y,su2+'0',col);
      /*printf("%d\n",x-l*6);*/
      suu=suu/10;
      l++;
   }

}

void chset3(int a, int b,int c,int ss)
{
   if(c=='1') a_write3(a,b,chr_1y, ss);
   if(c=='2') a_write3(a,b,chr_2y, ss);
   if(c=='3') a_write3(a,b,chr_3y, ss);
   if(c=='4') a_write3(a,b,chr_4y, ss);
   if(c=='5') a_write3(a,b,chr_5y, ss);
   if(c=='6') a_write3(a,b,chr_6y, ss);
   if(c=='7') a_write3(a,b,chr_7y, ss);
   if(c=='8') a_write3(a,b,chr_8y, ss);
   if(c=='9') a_write3(a,b,chr_9y, ss);
   if(c=='0') a_write3(a,b,chr_0y, ss);
 
}

void a_write3(int a,int b,unsigned char *c,int ss)
{
   int s,t,u=0;

   for(s=0;s<16;s++){
       for(t=0;t<12;t++){
           if(*(c+u) == 4)  box2(a+t,b+s,1,0); 
           if(*(c+u) == 3)  box2(a+t,b+s,1,ss); 
           if(*(c+u) == 1)  box2(a+t,b+s,1,ss+30); 
           if(*(c+u) == 2)  box2(a+t,b+s,1,ss+60); 
       /*    else             box(a+t*2,b+s*2,2,0 ); */ 
           u++;
       }
   }

}


void chx(int a, int b,int ss)
{
   int l=0;

   chset2(a+(l  )*10  ,b,0x7c,ss);
   chset2(a+(l  )*10  ,b-9,0x7c,ss);
   chset2(a+(l  )*10  ,b+5,0x7c,ss);
   chset2(a+(l  )*10+43,b-9,0x7c,ss);
   chset2(a+(l  )*10+43,b,0x7c,ss);
   chset2(a+(l  )*10+43,b+5,0x7c,ss);
   chset2(a+(l  )*10+4,b+5,0x5f,ss);
   chset2(a+(l  )*10+4,b-18,0x5f,ss);
   chset2(a+(l  )*10+13,b+5,0x5f,ss);
   chset2(a+(l  )*10+13,b-18,0x5f,ss);
   chset2(a+(l  )*10+22,b+5,0x5f,ss);
   chset2(a+(l  )*10+22,b-18,0x5f,ss);
   chset2(a+(l  )*10+31,b+5,0x5f,ss);
   chset2(a+(l  )*10+31,b-18,0x5f,ss);
   chset2(a+(l  )*10+37,b+5,0x5f,ss);
   chset2(a+(l  )*10+37,b-18,0x5f,ss);
}

void chc(int a, int b,int ss)
{
   int i,j,iro;

    iro=ss;

    /* 120515 */
    if(iro==0){g_rgb(0x000000);}
    else if(iro==1){g_rgb(0xf00000);}
    else if(iro==2){g_rgb(0x00f000);}
    else if(iro==3){g_rgb(0x0000f0);}
    else if(iro==4){g_rgb(0xf0f000);}
    else if(iro==5){g_rgb(0xbb00bb);}
    else if(iro==6){g_rgb(0x00f0f0);}
    else if(iro==7){g_rgb(0xffffff);}
    else if(iro==8){g_rgb(0xff9010);}
    else if(iro==9){g_rgb(0xc04040);}
    else if(iro==10){g_rgb(0xff1493);}
    else if(iro==11){g_rgb(0xffaa88);}
    else if(iro==12){g_rgb(0xc0f000);}
    else if(iro==13){g_rgb(0xb8860b);}
    else if(iro==14){g_rgb(0x4b0082);}
    else if(iro==15){g_rgb(0xa0a0a0);}
    else{g_rgb(0xeeeeee);}

    g_fill(a+3,b-7,43,22);
}

